#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "EZPlayList.h"
#include "ID3TAG.h"


// external declaration
extern COLUMNSSTRUCT gCol[MAX_COL];
extern INITSTRUCT gParam;
extern STATGENRESTRUCT gStatGenre[MAX_GENRE];
extern winampGeneralPurposePlugin plugin;

// Internal declaration
typedef struct myitemfilter_tag 
{	LPSTR szName;
	int nCount;
	BOOL bCheck;
} MYITEMFILTER; 


#ifndef ListView_SetCheckState
   #define ListView_SetCheckState(hwndLV, i, fCheck)	\
      ListView_SetItemState(hwndLV, i,					\
		INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif

#define MY_URL "http://perso.club-internet.fr/boyerjl"
#define MY_EMAIL "mailto:boyerjl@club-internet.fr"

BOOL bFilterChange	= FALSE;
BOOL bColumnsChange = FALSE;
static int nOldSortColumnFilter = 0;
static BOOL bSortOrderAscandingFilter = TRUE;

// Dialog "About"
void AboutDlg_ShowHelp(HWND hWnd);

// Dialog "Option"
BOOL  OptionDlg_LoadParam(HWND hwndDlg);
BOOL  OptionDlg_SaveParam(HWND hwndDlg);
void  OptionDlg_RemoveCol(HWND hwndDlg);
void  OptionDlg_CheckToList(HWND hwndDlg, int idButton);
LRESULT OptionDlg_NotifyHandler( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam,	HINSTANCE hInst);

// Dialog "Filter"
LRESULT FilterDlg_NotifyHandler( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam,	HINSTANCE hInst);
void FilterDlg_Init(HWND hWndDlg);
void FilterDlg_loaditem(HWND hWndDlg);
int FilterDlg_saveitem(HWND hWndDlg);
int CALLBACK FilterDlg_ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
BOOL FilterDlg_DoContextMenu(HWND hWnd, WPARAM wParam, LPARAM lParam);
void FilterDlg_SelectAll(HWND hWnd, BOOL bSelect);
void FilterDlg_SelectToggle(HWND hWndDlg);

/* ************************************************************************ */
BOOL CALLBACK OptionDlg_Proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		OptionDlg_LoadParam(hwndDlg);
		return FALSE;
	
/*	case WM_NOTIFY:
		OptionDlg_NotifyHandler(hwndDlg, uMsg, wParam, lParam, plugin.hDllInstance);
		return TRUE;
*/		
	
	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:
			OptionDlg_SaveParam(hwndDlg);
		case IDCANCEL:
			EndDialog(hwndDlg,0);
			return TRUE;

		case IDC_SELECTALL:
		case IDC_NONE:
			bColumnsChange  = TRUE;
			SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_RESETCONTENT, 0, 0);
			for (i = 0; i < MAX_COL; i++)
			{	
				CheckDlgButton(hwndDlg,IDC_CHECK1+i, LOWORD(wParam) == IDC_SELECTALL ? 
					BST_CHECKED : BST_UNCHECKED);	
	
				if (LOWORD(wParam) == IDC_SELECTALL)
					SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_ADDSTRING, 0, (LPARAM)(LPSTR)gCol[i].szName);		
			}
			SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_SETCURSEL, 0, 0);
			break;

		
		case IDC_CHECK1:
		case IDC_CHECK2:
		case IDC_CHECK3:
		case IDC_CHECK4:
		case IDC_CHECK5:
		case IDC_CHECK6:
		case IDC_CHECK7:
		case IDC_CHECK8:
		case IDC_CHECK9:
		case IDC_CHECK10:
		case IDC_CHECK11:
		case IDC_CHECK12:
		case IDC_CHECK13:
			if (HIWORD(wParam) == BN_CLICKED)
			{	
				bColumnsChange  = TRUE;
				OptionDlg_CheckToList(hwndDlg, LOWORD(wParam));
			}
			return FALSE;

		case IDC_MOVEUP:
		case IDC_MOVEDOWN:
			bColumnsChange  = TRUE;
			ListboxMoveItem(GetDlgItem(hwndDlg, IDC_LISTCOLUMN), LOWORD(wParam) == IDC_MOVEUP);
			break;

		case IDC_LISTCOLUMN:
			if (HIWORD(wParam) == LBN_DBLCLK)
			{	
				bColumnsChange  = TRUE;
				OptionDlg_RemoveCol(hwndDlg);
			}
			break;
	
		}
		
	}
	return FALSE;
}


/****************************************************************************
* 
*    FUNCTION: OptionDlg_NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the Propertysheet
*
****************************************************************************/
/*
LRESULT OptionDlg_NotifyHandler( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam,
	HINSTANCE hInst)
{

	switch(((LPNMHDR) lParam)->code)
	{
	case PSN_SETACTIVE: 
			OptionDlg_LoadParam(hwndDlg);
			return(TRUE); 
	case PSN_KILLACTIVE: 
		if ( OptionDlg_SaveParam(hwndDlg)==TRUE)
			SetWindowLong(hwndDlg, DWL_MSGRESULT, FALSE); 
		else
			SetWindowLong(hwndDlg, DWL_MSGRESULT, TRUE); 
		return (TRUE);

	default:
		break;
	}
	return 0L;
}
*/

/* ************************************************************** */
BOOL  OptionDlg_LoadParam(HWND hwndDlg)
{
	int i,k;

	// Column options
	bColumnsChange  = FALSE;

	SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_RESETCONTENT, 0, 0);
	
	for (i = 0; i < MAX_COL; i++)
	{
		k = gParam.UseCol[i];
		if (k != -1)
		{	
			SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_ADDSTRING, 0, (LPARAM)(LPSTR)gCol[k].szName);
			CheckDlgButton(hwndDlg,IDC_CHECK1+k,BST_CHECKED);
		}
		else
			CheckDlgButton(hwndDlg,IDC_CHECK1+k,BST_UNCHECKED);
	}
	
	// Load options
	CheckRadioButton(hwndDlg, IDC_RADIO_EXPORTALLITEM, IDC_RADIO_EXPORTSELECTITEM, gParam.bExportAllItems == 0 ? IDC_RADIO_EXPORTALLITEM: IDC_RADIO_EXPORTSELECTITEM) ; 
	CheckRadioButton(hwndDlg, IDC_RADIO_FORMAT_TABLE, IDC_RADIO_FORMAT_LISTING, gParam.bExportHTML_Format == 0 ? IDC_RADIO_FORMAT_TABLE: IDC_RADIO_FORMAT_LISTING) ; 
	CheckDlgButton(hwndDlg, IDC_CHECK_LINKFILE, (UINT)(gParam.bExportHTML_Link == 1 ? BST_CHECKED : BST_UNCHECKED));  
	CheckRadioButton(hwndDlg, IDC_RADIO_DBLCLIC_PLAY,  IDC_RADIO_DBLCLIC_ENQUEUE, gParam.nDblClic == 0 ? IDC_RADIO_DBLCLIC_PLAY: IDC_RADIO_DBLCLIC_ENQUEUE); 
	CheckRadioButton(hwndDlg, IDC_RADIO_LOAD_EZPLAYLIST,  IDC_RADIO_LOAD_WINAMP, gParam.nOnStartup == 0 ? IDC_RADIO_LOAD_EZPLAYLIST: IDC_RADIO_LOAD_WINAMP); 
	
	
	return TRUE;
}


/* ************************************************************** */
BOOL  OptionDlg_SaveParam(HWND hwndDlg)
{
	int nCount, i, k;
	char szTmp[40];

	// Save options
	gParam.bExportAllItems= (IsDlgButtonChecked(hwndDlg, IDC_RADIO_EXPORTALLITEM) == BST_CHECKED ? 0 : 1);
	gParam.bExportHTML_Format = (IsDlgButtonChecked(hwndDlg, IDC_RADIO_FORMAT_TABLE) == BST_CHECKED ? 0 : 1);
	gParam.bExportHTML_Link = (IsDlgButtonChecked(hwndDlg, IDC_CHECK_LINKFILE) == BST_CHECKED ? 1 : 0);
	gParam.nDblClic = (IsDlgButtonChecked(hwndDlg, IDC_RADIO_DBLCLIC_PLAY) == BST_CHECKED ? 0 : 1);
	gParam.nOnStartup = (IsDlgButtonChecked(hwndDlg, IDC_RADIO_LOAD_EZPLAYLIST) == BST_CHECKED ? 0 : 1);
	
	// Columns options
	nCount = SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETCOUNT, 0, 0);	

	if (nCount == 0)
	{	MessageBox(hwndDlg, "At least 1 column must be present !!!",  
			"Error", MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	nCount = SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETCOUNT, 0, 0);

	for (i = 0; i < MAX_COL; i++)
		gParam.UseCol[i] = -1;

	for (i = 0; i < nCount; i++)
	{	SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
		for (k = 0; k < MAX_COL; k++)
		{
			if (strcmp(gCol[k].szName, szTmp)== 0)
			{
				gParam.UseCol[i] = k;
				break;
			}				
		}	
	}

	
	return TRUE;
}


/* ************************************************************** */
void  OptionDlg_CheckToList(HWND hwndDlg, int idx)
{	
	int i,j, nCount;

	idx -= IDC_CHECK1;

	if (IsDlgButtonChecked(hwndDlg,IDC_CHECK1 + idx))	
	{
		SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_ADDSTRING, 0, (LPARAM)(LPSTR)gCol[idx].szName);
	}
	else
	{
		char szTmp[40];
		nCount = SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETCOUNT, 0, 0);

		for (i = 0; i < nCount; i++)
		{	SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
			for (j = 0; j < MAX_COL; j++)
			{	if (strcmp(gCol[idx].szName, szTmp)== 0)
				{
					SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_DELETESTRING, i, 0);	
					SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_SETCURSEL, --nCount, 0);
					return;
				}
			}	
		}

	}
		
}


/* ************************************************************** */
void  OptionDlg_RemoveCol(HWND hwndDlg)
{	
	int i,j;
	char szTmp[40];

	i = SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETCURSEL, 0, 0);

	if (i == LB_ERR) 
		return;

	SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
	
	for (j = 0; j < MAX_COL; j++)
	{	if (strcmp(gCol[j].szName, szTmp) == 0)
		{
			CheckDlgButton(hwndDlg,IDC_CHECK1+j, BST_UNCHECKED);
			SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_DELETESTRING, i, 0);	
			SendDlgItemMessage(hwndDlg, IDC_LISTCOLUMN, LB_SETCURSEL, i, 0);
			return;
		}
	}	
	
}





// //////////////////////////////
// End part for DlgColumns Dialog
// //////////////////////////////


/* ************************************************************** */
BOOL CALLBACK AboutDlg_Proc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
    static HFONT hFont;
    UINT idTimer = 1;
    static UINT i;
    static HICON aIcon[7];
	static HCURSOR hLinkCursor;
	static RECT rcLink, rcEmail;
	POINT pt;

    switch (message) 
    {
    case WM_INITDIALOG:
		{
		HANDLE hrscHelp; 
		LPSTR lpHelp; 
		HRSRC hrsc;

		hrsc = FindResource(plugin.hDllInstance, MAKEINTRESOURCE(IDR_DATAHELP), "DATAHELP"); 
		hrscHelp = LoadResource(plugin.hDllInstance, hrsc); 
		lpHelp = LockResource(hrscHelp); 
		SetWindowText(GetDlgItem(hWnd, IDC_EDIT_HELP), (LPSTR)lpHelp);
		UnlockResource(hrscHelp); 
		FreeResource(hrscHelp); 

		hLinkCursor = LoadCursor(plugin.hDllInstance,MAKEINTRESOURCE(IDC_HYPERLINK));

		hFont = CreateFont(48, 0, 0, 0, FW_BOLD, TRUE, FALSE,0,0,0,0,0,0, "Arial");
     
        for (i = 0; i<7; i++)
			aIcon[i] =  LoadIcon(plugin.hDllInstance, MAKEINTRESOURCE (IDI_ICON1+i));
         
        i = 0;
        SendDlgItemMessage(hWnd, IDC_ANIM_ICON, STM_SETICON,(WPARAM)aIcon[i++], 0);                
        SetTimer(hWnd, idTimer, 250, (TIMERPROC)NULL);
		}             
        return TRUE;

	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			RECT rectText;
			COLORREF OldColor;
			HFONT hOldFont;
			char szTitle[]="EZ-Playlist";
			LOGFONT lf;	
			HFONT hFontHyperLink;

			hDC = BeginPaint(hWnd, &ps);
			
			SetBkMode(hDC, TRANSPARENT);
			GetClientRect(hWnd ,&rectText);
			rectText.top = 16;
			rectText.bottom = 100;
			
			hOldFont = SelectObject(hDC, hFont);

			// draw text in DC
			OldColor = SetTextColor(hDC,  GetSysColor( COLOR_3DHILIGHT));

			DrawText(hDC,  szTitle, strlen(szTitle), &rectText, DT_SINGLELINE | DT_CENTER );
			SetTextColor(hDC, GetSysColor( COLOR_3DSHADOW));
			rectText.left--;
			rectText.top--;

			DrawText(hDC,  szTitle, strlen(szTitle), &rectText, DT_SINGLELINE | DT_CENTER );

			// restore old text color
			SetTextColor(hDC, OldColor);
			// restore old font
			SelectObject(hDC, hOldFont);


			// Hyper Link + Email
			ZeroMemory(&lf,sizeof(lf));
			lstrcpy (lf.lfFaceName, "MS Sans Serif");
			lf.lfHeight = 5;
			lf.lfWidth  = 5;
			lf.lfUnderline = TRUE;
			lf.lfOutPrecision = OUT_TT_PRECIS;
			hFontHyperLink = CreateFontIndirect ((LPLOGFONT) &lf);
			if (hFontHyperLink!=NULL) 
			{
				SIZE sSize;
				RECT rcClient;

				GetClientRect(hWnd, &rcClient);

				hOldFont=SelectObject(hDC, hFontHyperLink);
				SetBkMode(hDC,TRANSPARENT);
				SetTextAlign(hDC,TA_LEFT);
				SetTextColor(hDC,RGB(0,0,255));

				GetTextExtentPoint32(hDC,MY_URL,strlen(MY_URL) ,&sSize);
				rcLink.right = rcClient.right - 16; 
				rcLink.left = rcLink.right - sSize.cx;
				rcLink.bottom = rcClient.bottom - 8; 
				rcLink.top = rcLink.bottom - sSize.cy;
				TextOut(hDC,rcLink.left,rcLink.top ,MY_URL, strlen(MY_URL));

				GetTextExtentPoint32(hDC,MY_EMAIL,strlen(MY_EMAIL) ,&sSize);
				rcEmail.right = rcClient.right - 16; 
				rcEmail.left = rcEmail.right - sSize.cx;
				rcEmail.bottom = rcClient.bottom - sSize.cy - 12; 
				rcEmail.top = rcEmail.bottom - sSize.cy;
				TextOut(hDC,rcEmail.left,rcEmail.top ,MY_EMAIL, strlen(MY_EMAIL));

				SelectObject(hDC, hOldFont);
				DeleteObject (hFontHyperLink); 
			}


			EndPaint(hWnd, &ps);

		}
		return TRUE;

	case WM_LBUTTONUP:

		GetCursorPos(&pt);
		ScreenToClient(hWnd,&pt);

		if (PtInRect(&rcLink, pt)) 
		{
			HINSTANCE r = ShellExecute(hWnd,NULL, MY_URL, NULL,NULL,SW_SHOWNORMAL);
		}
		else if (PtInRect(&rcEmail, pt)) 
		{
			HINSTANCE r = ShellExecute(hWnd,NULL, MY_EMAIL, NULL,NULL,SW_SHOWNORMAL);
		}
		
		
		return FALSE;

	case WM_MOUSEMOVE:
		GetCursorPos(&pt);
		ScreenToClient(hWnd,&pt);

		if (PtInRect(&rcLink, pt) || PtInRect(&rcEmail, pt)) 
		{
			SetCursor(hLinkCursor);
			return TRUE;
		} 
		
		return FALSE;

    case WM_TIMER:
        SendDlgItemMessage(hWnd, IDC_ANIM_ICON, STM_SETICON,(WPARAM)aIcon[i++], 0);                
        if (i == 7)
            i = 0;
        break;                  
   
    case WM_COMMAND:
		switch (wParam) 
        {
			case IDC_BUTTON_HELP:
				AboutDlg_ShowHelp(hWnd);
				return TRUE;
			case IDOK:
			case IDCANCEL:
				EndDialog(hWnd,0);
				return TRUE;
        }
        break;

    case WM_DESTROY:
		if (hFont != NULL)
            DeleteObject (hFont);

        for (i=0; i<7; i++) 
            DeleteObject(aIcon[i]);
        KillTimer(hWnd, idTimer);
        return FALSE;

    }
    return FALSE;
}

/* ************************************************************** */

void AboutDlg_ShowHelp(HWND hWnd)
{
	char szButton[40];
	BOOL bShowHelp;
	HWND hwndButton = GetDlgItem(hWnd, IDC_BUTTON_HELP);
	GetWindowText(hwndButton, (LPSTR)szButton, sizeof(szButton));

	if (strcmp(szButton, "Help >>")==0)
	{
		strcpy(szButton, "<< About");
		bShowHelp = TRUE;
	}
	else
	{
		strcpy(szButton, "Help >>");
		bShowHelp = FALSE;
	}

	SetWindowText(hwndButton, (LPSTR)szButton);
	ShowWindow(GetDlgItem(hWnd, IDC_EDIT_HELP), bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(hWnd, IDC_FRAME_COPYRIGHT), !bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(hWnd, IDC_COPYRIGHT), !bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(hWnd, IDC_COPYRIGHT2), !bShowHelp ? SW_SHOW : SW_HIDE);			
}
 
// //////////////////////////////
// End part for DlgAbout Dialog
// //////////////////////////////


/* ************************************************************** */
BOOL CALLBACK FilterDlg_Proc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    static HFONT hFont;
    UINT idTimer = 1;
    static UINT i;
    static HICON aIcon[7];

    switch (message) 
    {
    case WM_INITDIALOG:
		FilterDlg_Init(hwndDlg);
		FilterDlg_loaditem(hwndDlg);
        return FALSE;

	case WM_NOTIFY:
		FilterDlg_NotifyHandler(hwndDlg, message, wParam, lParam, plugin.hDllInstance);
		return TRUE;

	case WM_CONTEXTMENU: 
			if(FilterDlg_DoContextMenu(hwndDlg, wParam, lParam)) 
				return FALSE; 
			break; 
	
	case WM_DESTROY:
		FilterDlg_saveitem(hwndDlg);
		return TRUE;
	
	case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case ID_FILTER_SELECTALL:	// from menu
			case IDC_FILTERSELECTALL:	// from button
				FilterDlg_SelectAll(hwndDlg, TRUE);
				return FALSE;

			case ID_FILTER_SELECTNONE:	
			case IDC_FILTERSELECTNONE:
				FilterDlg_SelectAll(hwndDlg, FALSE);
				return FALSE;
			
			case ID_FILTER_SELECTTOGGLE:
			case IDC_FILTERSELECTTOGGLE:
				FilterDlg_SelectToggle(hwndDlg);
				return FALSE;

			case IDOK:
			case IDCANCEL:
				EndDialog(hwndDlg,0);
				return TRUE;

			}

    }
    return FALSE;
}

/* ************************************************************** */
void FilterDlg_Init(HWND hWndDlg)
{
	LV_COLUMN lvc;				// list view column structure
	char szText[80];
	HWND hlvwfilter;

	
	hlvwfilter = GetDlgItem(hWndDlg, IDC_LVW_FILTER);

	ListView_SetExtendedListViewStyle(hlvwfilter, LVS_EX_FULLROWSELECT | LVS_EX_CHECKBOXES );

	// Delete columns
	ListView_DeleteColumn(hlvwfilter,0);
	ListView_DeleteColumn(hlvwfilter,1);


	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.pszText = szText;

	// Genre
	lvc.iSubItem = 0;
	lvc.fmt = LVCFMT_LEFT;	
	lvc.cx = 115;			
	strcpy(szText, "Genre");
	ListView_InsertColumn (hlvwfilter, 0, &lvc);

	// Count genre
	lvc.iSubItem = 1;
	lvc.fmt = LVCFMT_RIGHT;	
	lvc.cx = 44;			
	strcpy(szText, "Count");
	ListView_InsertColumn (hlvwfilter, 1, &lvc);
}

/* ************************************************************** */
void FilterDlg_loaditem(HWND hWndDlg)
{
	LV_ITEM lvi;				// list view item structure
	char szText[80];
	int i, iItem;
	HWND hlvwfilter;

	hlvwfilter = GetDlgItem(hWndDlg, IDC_LVW_FILTER);


	bFilterChange = FALSE;

	ListView_DeleteAllItems(hlvwfilter); 

	 // Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.stateMask = 0; 
	lvi.iImage = 0;
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	iItem = 0;
	for (i = 0; i<MAX_GENRE; i++)
	{
		if (gStatGenre[i].nCount > 0)
		{
			BOOL bCheck;
			MYITEMFILTER *pItem;

			strcpy(szText, get_id3_genre((unsigned char)i));

			pItem = LocalAlloc(LPTR, sizeof(MYITEMFILTER));          
			pItem->szName = DupString(szText);
			pItem->nCount = gStatGenre[i].nCount;
			pItem->bCheck = gStatGenre[i].bCheck;

			lvi.iItem = iItem; 
			lvi.iSubItem = 0;         
			lvi.lParam = (LPARAM) pItem;    // item data  
			ListView_InsertItem(hlvwfilter, &lvi);  

			bCheck = gStatGenre[i].bCheck;

			ListView_SetCheckState(hlvwfilter, iItem, bCheck);

			iItem++;
		}		
	}
}

/* ************************************************************** */
int FilterDlg_saveitem(HWND hWndDlg)
{
	int i, nCount, idx, nCountCheck;
	HWND hlvwfilter;
	BOOL bCheckState;
	LV_ITEM lvi;
	MYITEMFILTER *pItem;

	hlvwfilter = GetDlgItem(hWndDlg, IDC_LVW_FILTER);
	
	nCount = ListView_GetItemCount(hlvwfilter);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask = LVIF_PARAM ; 
 
	for (nCountCheck = 0, i = 0; i < nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(hlvwfilter, &lvi);

		pItem = (MYITEMFILTER*)lvi.lParam;    // item data  
			
		idx = find_genre_id(pItem->szName);
			
			
		if (ListView_GetCheckState(hlvwfilter, i))
		{
			bCheckState = TRUE;
			nCountCheck++;
		}
		else
			bCheckState  = FALSE;

		if (gStatGenre[idx].bCheck != bCheckState) 
				bFilterChange = TRUE;

		
		gStatGenre[idx].bCheck = bCheckState;
			
	}
	return (nCountCheck);
}

/****************************************************************************
* 
*    FUNCTION: DlgFilter_NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the list view window.
*
****************************************************************************/
LRESULT FilterDlg_NotifyHandler( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam,
	HINSTANCE hInst)
{
	LV_DISPINFO FAR * pnmv = (LV_DISPINFO FAR *) lParam;
	NM_LISTVIEW *pNm = (NM_LISTVIEW *)lParam;
	
	
	switch(((LPNMHDR) lParam)->code)
	{
/*
	case PSN_SETACTIVE: 
		FilterDlg_loaditem(hwndDlg);
		return(TRUE); 

	case PSN_KILLACTIVE: 
		FilterDlg_saveitem(hwndDlg);
		//SetWindowLong(hwndDlg, DWL_MSGRESULT, TRUE); 
		
		return(TRUE); 
*/
		case LVN_GETDISPINFO:
			// Provide the item or subitem's text, if requested. 
		    if (pnmv->item.mask & LVIF_TEXT) 
			{ 
				char szCol[80];
				MYITEMFILTER *pItem = (MYITEMFILTER *) (pnmv->item.lParam); 


				switch(pnmv->item.iSubItem)
				{
					case 0: lstrcpy(szCol, (LPSTR)pItem->szName); break;
					case 1: wsprintf(szCol, "%d", pItem->nCount); break;
				}

				lstrcpy(pnmv->item.pszText, (LPSTR)szCol);
				
			}
			break;

		case LVN_COLUMNCLICK:
			if (nOldSortColumnFilter == pNm->iSubItem)
				bSortOrderAscandingFilter = !bSortOrderAscandingFilter;

			nOldSortColumnFilter = pNm->iSubItem;
			ListView_SortItems( pNm->hdr.hwndFrom, FilterDlg_ListViewCompareProc,
								(LPARAM)(pNm->iSubItem));
			break;

		default:
			break;
	}
	return 0L;
}


/**************************************************************************** */
int CALLBACK FilterDlg_ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{     
	MYITEMFILTER *pItem1 = (MYITEMFILTER *) lParam1; 
    MYITEMFILTER *pItem2 = (MYITEMFILTER *) lParam2;      
	int iCmp; 

	// Compare the specified column. 
	switch(lParamSort)
	{
		case 0:
			iCmp = lstrcmpi(pItem1->szName, pItem2->szName);
			break;
		case 1:
			if (pItem1->nCount == pItem2->nCount)
				iCmp = 0;
			else if (pItem1->nCount > pItem2->nCount)
				iCmp = 1;
			else
				iCmp = -1;
			break;

	}

	if (!bSortOrderAscandingFilter)
		iCmp *= -1;
	
	return (iCmp); 
}

/* ************************************************************ */
BOOL FilterDlg_DoContextMenu(HWND hWnd, WPARAM wParam, LPARAM lParam) 
{ 
	HMENU hMenuLoad, hMenu; 

	hMenuLoad = LoadMenu(plugin.hDllInstance, MAKEINTRESOURCE(IDR_MENU1)); 
	hMenu = GetSubMenu(hMenuLoad, 2); 

	TrackPopupMenu(hMenu, 
				  TPM_LEFTALIGN | TPM_RIGHTBUTTON, 
				  LOWORD(lParam), 
				  HIWORD(lParam), 
				  0, 
				  hWnd, 
				  NULL); 

	DestroyMenu(hMenuLoad); 

	return TRUE; 
} 

/* ************************************************************** */
void FilterDlg_SelectAll(HWND hWndDlg, BOOL bSelect)
{
	int i, nCount;
	HWND hlvwfilter = GetDlgItem(hWndDlg, IDC_LVW_FILTER);
	
	nCount = ListView_GetItemCount(hlvwfilter);
 
	for (i = 0; i < nCount; i++)
		ListView_SetCheckState(hlvwfilter, i, (bSelect ? 1: 0));
}

/* ************************************************************** */
void FilterDlg_SelectToggle(HWND hWndDlg)
{
	int i, nCount;
	BOOL bCheckState;

	HWND hlvwfilter = GetDlgItem(hWndDlg, IDC_LVW_FILTER);
	
	nCount = ListView_GetItemCount(hlvwfilter);
 
	for (i = 0; i < nCount; i++)
	{
		if (ListView_GetCheckState(hlvwfilter, i))
			bCheckState = 0;
		else
			bCheckState = 1;

		ListView_SetCheckState(hlvwfilter, i, bCheckState);
	}
}
