#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <winbase.h>		// MoveFile: Rename file

#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "EZPlayList.h"
#include "ID3TAG.h"

extern HWND m_hwndList;
extern winampGeneralPurposePlugin plugin;
extern INITSTRUCT gParam;


const char *listFrmt[5] = {"Artist", "Title", "Album", "Year", "Comment"};

// 1: Edit Tag/Flag, 
// 2: Mass Tag, 
// 4: Rename from file, 
// 8: Write Tag from filename 
#define MAX_CTRLID 45
int gCtrlID[MAX_CTRLID][2] =
{
	{IDC_TAG_EDIT_FILENAME          ,1 ,},
	{IDC_TAG_STATIC_TITLE           ,1 ,},
	{IDC_TAG_STATIC_ARTIST          ,1 ,},
	{IDC_TAG_STATIC_ALBUM           ,1 ,},
	{IDC_TAG_STATIC_YEAR            ,1 ,},
	{IDC_TAG_STATIC_GENRE           ,1 ,},
	{IDC_TAG_STATIC_COMMENT         ,1 ,},
	{IDC_TAG_FRAME_EDITTAG          ,1 ,}, 
	{IDC_TAG_BTN_WRITE              ,1 ,},
	{IDC_TAG_FRAME_INFOMPEG         ,1 ,},
	{IDC_TAG_MPEGINFO1              ,1 ,},
	{IDC_TAG_MPEGINFO2              ,1 ,},
	{IDC_TAG_FRAME_REMOVE           ,2 ,},
	{IDC_TAG_CHK_REMOVETAG          ,2 ,},
	{IDC_TAG_CHK_TITLE              ,2 ,},
	{IDC_TAG_CHK_ARTIST             ,2 ,},
	{IDC_TAG_CHK_ALBUM              ,2 ,},
	{IDC_TAG_CHK_YEAR               ,2 ,},
	{IDC_TAG_CHK_GENRE              ,2 ,},
	{IDC_TAG_CHK_COMMENT            ,2 ,},
	{IDC_TAG_EDIT_TITLE             ,3 ,},
	{IDC_TAG_EDIT_ARTIST            ,3 ,},
	{IDC_TAG_EDIT_ALBUM             ,3 ,},
	{IDC_TAG_EDIT_YEAR              ,3 ,},
	{IDC_TAG_EDIT_GENRE             ,3 ,},
	{IDC_TAG_EDIT_COMMENT           ,3 ,},
	{IDC_TAG_CHCKARTIST_FRMT        ,12,},
	{IDC_TAG_CHCKTITLE_FRMT         ,12,},
	{IDC_TAG_CHCKYEAR_FRMT          ,12,},
	{IDC_TAG_CHCKALBUM_FRMT         ,12,},
	{IDC_TAG_CHCKCOMMENT_FRMT       ,12,},
	{IDC_TAG_LIST_FRMT              ,12,},
	{IDC_TAG_MOVEUP                 ,12,},
	{IDC_TAG_MOVEDOWN               ,12,},
	{IDC_TAG_SELECTALL              ,12,},   
	{IDC_TAG_NONE                   ,12,}, 
	{IDC_TAG_BTN_GO                 ,14,}, 
	{IDC_TAG_CHK_LOG                ,14,}, 
	{IDC_TAG_EDIT_LOG               ,14,}, 
	{IDC_TAG_BTN_LOG                ,14,}, 
	{IDC_TAG_STATIC_FILE_FRMT       ,12,}, 
	{IDC_TAG_EDIT_FRMT              ,12,},
	{IDC_TAG_FRAME1_FRMT            ,4, }, 
	{IDC_TAG_FRAME2_FRMT            ,8} 

};



int gnShowPart = 1;
BOOL bChange;
BOOL bIsLoading;

// Dialog "Tag"
BOOL CALLBACK TagDlg_Proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT TagDlg_NotifyHandler( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam,	HINSTANCE hInst);

void TagDlg_LoadParam(HWND hwndDlg);
void TagDlg_SaveParam(HWND hwndDlg);
void TagDlg_Init(HWND hwndDlg);
void TagDlg_InitFileList(HWND hwndDlg);
void TagDlg_ShowInfo(HWND hwndDlg);
void TagDlg_ShowCtrlID(HWND hwndDlg);
void TagDlg_CheckRemoveTag(HWND hwndDlg);
void TagDlg_CheckTag2Edit(HWND hwndDlg, int);
void TagDlg_CheckTag2ListFrmt(HWND hwndDlg, int nID);
void TagDlg_RemoveCol(HWND hwndDlg);
void TagDlg_UpdateFormat(HWND hwndDlg);
void TagDlg_SelectAll(HWND hwndDlg, int);
void TagDlg_EnableGOButton(HWND hwndDlg);
void TagDlg_EnableWriteButton(HWND hwndDlg, BOOL);
void TagDlg_EnableLOG(HWND hwndDlg);
void TagDlg_BtnLOG(HWND hwndDlg);
void TagDlg_IsDirty(HWND hwndDlg);
void TagDlg_WriteTag(HWND hwndDlg);
void TagDlg_BtnGO(HWND hwndDlg);
BOOL TagDlg_MassTAG(HWND hwndDlg, int iItem, BOOL bRemoveTAG);
BOOL TagDlg_RenameFileFromTAG(HWND hwndDlg, int iItem);
BOOL TagDlg_WriteTAGFromFile(HWND hwndDlg, int iItem);

/* ************************************************************************ */
BOOL CALLBACK TagDlg_Proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		TagDlg_Init(hwndDlg);
		TagDlg_LoadParam(hwndDlg);
		TagDlg_InitFileList(hwndDlg);
		TagDlg_ShowCtrlID(hwndDlg);
		return FALSE;

	
	case WM_DESTROY:
		TagDlg_IsDirty(hwndDlg);
		TagDlg_SaveParam(hwndDlg);
		return 0;
	
/*	case WM_NOTIFY:
		TagDlg_NotifyHandler(hwndDlg, uMsg, wParam, lParam, plugin.hDllInstance);
		return TRUE;
*/	
	case WM_COMMAND: 
		switch (LOWORD(wParam))
		{ 
		case IDOK:
		case IDCANCEL:
			EndDialog(hwndDlg,0);
			return TRUE;

		case IDC_TAG_LIST_FILE:	    
			if (HIWORD(wParam) == LBN_SELCHANGE)
			{
				TagDlg_IsDirty(hwndDlg);	
				TagDlg_ShowInfo(hwndDlg);	
			}
			return TRUE;

		case IDC_TAG_EDIT_TITLE:	    
		case IDC_TAG_EDIT_ARTIST:	    
		case IDC_TAG_EDIT_ALBUM:	    
		case IDC_TAG_EDIT_COMMENT:	    
		case IDC_TAG_EDIT_YEAR:	  
			if (HIWORD(wParam) == EN_CHANGE) 
				TagDlg_EnableWriteButton(hwndDlg, TRUE);
			return TRUE;

		case IDC_TAG_EDIT_GENRE:	    
			if (HIWORD(wParam) == CBN_SELCHANGE)
				TagDlg_EnableWriteButton(hwndDlg, TRUE);
			return TRUE;
		
		case IDC_TAG_RADIO1:
		case IDC_TAG_RADIO2:
		case IDC_TAG_RADIO3:
		case IDC_TAG_RADIO4:
			gnShowPart = 1 << (LOWORD(wParam) - IDC_TAG_RADIO1);
			TagDlg_IsDirty(hwndDlg);	
			TagDlg_ShowCtrlID(hwndDlg);
			return TRUE;

		case IDC_TAG_BTN_WRITE:
			TagDlg_WriteTag(hwndDlg);
			return TRUE;
		
		case IDC_TAG_BTN_GO:
			TagDlg_BtnGO(hwndDlg);
			return TRUE;

		case IDC_TAG_CHK_ARTIST:
		case IDC_TAG_CHK_TITLE:
		case IDC_TAG_CHK_ALBUM:
		case IDC_TAG_CHK_YEAR:
		case IDC_TAG_CHK_GENRE:
		case IDC_TAG_CHK_COMMENT:
			if (HIWORD(wParam) == BN_CLICKED)
			{
				TagDlg_CheckTag2Edit(hwndDlg, LOWORD(wParam));
				
				CheckDlgButton(hwndDlg, IDC_TAG_CHK_REMOVETAG, BST_UNCHECKED);  
			}
			return TRUE;

		case IDC_TAG_CHK_REMOVETAG:
			if (HIWORD(wParam) == BN_CLICKED)
				TagDlg_CheckRemoveTag(hwndDlg);
			return TRUE;


		case IDC_TAG_CHCKARTIST_FRMT:
		case IDC_TAG_CHCKTITLE_FRMT:
		case IDC_TAG_CHCKALBUM_FRMT:
		case IDC_TAG_CHCKYEAR_FRMT:
		case IDC_TAG_CHCKCOMMENT_FRMT:
			if (HIWORD(wParam) == BN_CLICKED)
			{	TagDlg_CheckTag2ListFrmt(hwndDlg, LOWORD(wParam));
				TagDlg_UpdateFormat(hwndDlg);
			}
			return TRUE;

		case IDC_TAG_SELECTALL:
		case IDC_TAG_NONE:
			TagDlg_SelectAll(hwndDlg, LOWORD(wParam));
			TagDlg_UpdateFormat(hwndDlg);
			return TRUE;

		case IDC_TAG_MOVEUP:
		case IDC_TAG_MOVEDOWN:
			ListboxMoveItem(GetDlgItem(hwndDlg, IDC_TAG_LIST_FRMT), LOWORD(wParam) == IDC_TAG_MOVEUP);
			TagDlg_UpdateFormat(hwndDlg);
			break;

		case IDC_TAG_LIST_FRMT:
			if (HIWORD(wParam) == LBN_DBLCLK)
			{	TagDlg_RemoveCol(hwndDlg);
				TagDlg_UpdateFormat(hwndDlg);
			}
			break;

		case IDC_TAG_CHK_LOG:
			TagDlg_EnableLOG(hwndDlg);
			return TRUE;
		case IDC_TAG_BTN_LOG:
			TagDlg_BtnLOG(hwndDlg);
			return TRUE;
		}
	}
	return FALSE;
}


/****************************************************************************
* 
*    FUNCTION: TagDlg_NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the Propertysheet
*
****************************************************************************/
/*
LRESULT TagDlg_NotifyHandler( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam, HINSTANCE hInst)
{
	switch(((LPNMHDR) lParam)->code)
	{
		case PSN_SETACTIVE: 
			TagDlg_InitFileList(hwndDlg);
			TagDlg_ShowCtrlID(hwndDlg);
			return(TRUE); 
	
		case PSN_KILLACTIVE: 
			TagDlg_IsDirty(hwndDlg);	
			return (TRUE);

		default:
			break;
	}
	return 0L;
}
*/

/* ************************************************************** */
void TagDlg_LoadParam(HWND hwndDlg)
{
	int i;
	
	for (i = 0; i < 6; i++)
	{	CheckDlgButton(hwndDlg,IDC_TAG_CHK_TITLE+i,(gParam.nRemoveTAG & (1<<i))?BST_CHECKED:BST_UNCHECKED);	
		TagDlg_CheckTag2Edit(hwndDlg, IDC_TAG_CHK_TITLE+i);
	}


	// Format Column options 
	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_RESETCONTENT, 0, 0);
	
	for (i = 0; i < 5; i++)
	{
		int k = gParam.FrmtCol[i];

		if (k != -1)
		{	
			SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_ADDSTRING, 0, (LPARAM)(LPSTR)listFrmt[k]);
			CheckDlgButton(hwndDlg,IDC_TAG_CHCKARTIST_FRMT+k,BST_CHECKED);
		}
	}

	TagDlg_UpdateFormat(hwndDlg);
}


/* ************************************************************** */
void TagDlg_SaveParam(HWND hwndDlg)
{
	int i, k, nCount ;
	char szTemp[40];

	gParam.nRemoveTAG = 0;

	for (i = 0; i < 6; i++)
		if (IsDlgButtonChecked(hwndDlg,IDC_TAG_CHK_TITLE+i))
			gParam.nRemoveTAG |= 1<<i;


	// Save Order format columns
	for (i = 0; i < 5; i++)	
		gParam.FrmtCol[i] = -1;

	nCount = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETCOUNT, 0, 0);
	for (i = 0; i < nCount; i++)
	{	
		SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTemp );
		
		for (k = 0; k < 5; k++)
		{	if (strcmp(listFrmt[k], szTemp)== 0)
			{	gParam.FrmtCol[i] = k;
				break;
			}				
		}	
	}

}


/* ************************************************************************ */
void TagDlg_Init(HWND hwndDlg)
{
	int i;
	int nRadio;

	TagDlg_EnableWriteButton(hwndDlg, FALSE);

	// Set MAX LENGTH Edit TAG
	SendDlgItemMessage( hwndDlg, IDC_TAG_EDIT_TITLE, EM_SETLIMITTEXT , 30L, 0L);
	SendDlgItemMessage( hwndDlg, IDC_TAG_EDIT_ARTIST, EM_SETLIMITTEXT , 30L, 0L);
	SendDlgItemMessage( hwndDlg, IDC_TAG_EDIT_ALBUM, EM_SETLIMITTEXT , 30L, 0L);
	SendDlgItemMessage( hwndDlg, IDC_TAG_EDIT_YEAR, EM_SETLIMITTEXT , 4L, 0L);
	SendDlgItemMessage( hwndDlg, IDC_TAG_EDIT_COMMENT, EM_SETLIMITTEXT , 30L, 0L);

	// Load Genre in Comobox
	SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE, CB_RESETCONTENT, 0, 0);
	for (i = 0; i<MAX_GENRE; i++)
		SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE, CB_ADDSTRING, 0, (LPARAM)(LPSTR)get_id3_genre((unsigned char)i));			

	// Switch on correct Part
	switch (gnShowPart)
	{	case 1:  nRadio = IDC_TAG_RADIO1; break;
		case 2:  nRadio = IDC_TAG_RADIO2; break;
		case 4:  nRadio = IDC_TAG_RADIO3; break;
		case 8:  nRadio = IDC_TAG_RADIO4; break;
		default: nRadio = IDC_TAG_RADIO1; break;
	}
	CheckRadioButton(hwndDlg, IDC_TAG_RADIO1, IDC_TAG_RADIO4, nRadio); 
}

/* ************************************************************************ */
void TagDlg_InitFileList(HWND hwndDlg)
{
	int i, nCount, idx;
	LV_ITEM lvi;
	MYITEM *pItem;
	char szTemp[1024],  *p, *ext;
	
	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE, LB_RESETCONTENT, 0, 0);

	nCount = ListView_GetItemCount(m_hwndList);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_PARAM; 
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		ext = strrchr(pItem->pFileName, '.');

		if (ext == 0) 
			continue;

		if (strncmp(ext, ".mp3", 4)==0)
		{
			p = strrchr(pItem->pFileName, '\\');

			if (p)
				strcpy(szTemp, p+1);
			else
				strcpy(szTemp, pItem->pFileName);

			p = szTemp;
			*p = toupper(*p);

			idx = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE, LB_ADDSTRING, 0, (LPARAM)(LPSTR)szTemp);		
			SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE, LB_SETITEMDATA, idx, (LPARAM)pItem);		
		}		
	}	


	// select info for 1st song
	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_SETSEL, TRUE, 0);
	TagDlg_ShowInfo(hwndDlg);
}


/* ************************************************************************ */
void TagDlg_ShowInfo(HWND hwndDlg)
{
	DWORD dwLen, dwIndex;
	char szTemp[128];
	MYITEM *pItem;
//	const char *emphasis[4] = {"None", "50/15 ms", " ", "CCIT J.17"};
//	const char *bool_label[2] = {"No", "Yes"};

	bIsLoading = TRUE;

	// Show info only for "Edit Tag Part"
	if (gnShowPart != 1) 
		return;

	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETCURSEL, 0, 0);
	if (dwIndex == LB_ERR) 	return;
	dwLen = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)dwIndex, (LPARAM)((LPSTR) szTemp));
	if (dwLen == LB_ERR)	return;

	pItem = (MYITEM*)dwLen;

	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_FILENAME), (LPSTR)pItem->pFileName);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ARTIST), (LPSTR)pItem->pData->artist);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_TITLE), (LPSTR)pItem->pData->title);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ALBUM), (LPSTR)pItem->pData->album);;
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_YEAR), (LPSTR)pItem->pData->year);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_COMMENT), (LPSTR)pItem->pData->comment);
	
	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_FINDSTRING ,
				-1, (LPARAM)(LPSTR)get_id3_genre(pItem->pData->genre));
	if (dwIndex == CB_ERR)	dwIndex = -1;
	 
	SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_SETCURSEL  , dwIndex, 0L);

	szTemp[0] = '\0';
	mpg123_MPEGInfo(pItem->pData, szTemp, 0);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_MPEGINFO1), (LPSTR)szTemp);
    szTemp[0] = '\0';
	mpg123_MPEGInfo(pItem->pData, szTemp, 1);
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_MPEGINFO2), (LPSTR)szTemp);

	bIsLoading = FALSE;
	TagDlg_EnableWriteButton(hwndDlg, FALSE);
}

/* ************************************************************************ */
void TagDlg_ShowCtrlID(HWND hwndDlg)
{
	int i;
	
	// Show/Hide visible ctrl for good part
    for (i = 0; i< MAX_CTRLID; i++)
		ShowWindow(GetDlgItem(hwndDlg, gCtrlID[i][0]),  (gCtrlID[i][1] & gnShowPart) ? SW_SHOW : SW_HIDE);			


	// Init ctrl for specific part	
	switch(gnShowPart)
	{
	case 1:
		for (i = 0; i< 6; i++)
			EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_EDIT_TITLE + i), TRUE);
		
		TagDlg_ShowInfo(hwndDlg);	// Refresh select info
		break;

	case 2:
		for (i = 0; i< 6; i++)
			TagDlg_CheckTag2Edit(hwndDlg, IDC_TAG_CHK_TITLE + i);

		// clear all edit
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_FILENAME), (LPSTR)"");
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ARTIST), (LPSTR)"");
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_TITLE), (LPSTR)"");
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ALBUM), (LPSTR)"");;
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_YEAR), (LPSTR)"");
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_COMMENT), (LPSTR)"");
		SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_SETCURSEL, -1, 0);

		TagDlg_EnableGOButton(hwndDlg);
		break;

	case 4:
	case 8:
		TagDlg_UpdateFormat(hwndDlg);
		break;
	}
	
	
	EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_CHK_ONLYSELECTED),  gnShowPart!=1);      

}

/* ************************************************************************ */
void TagDlg_CheckRemoveTag(HWND hwndDlg)
{
	int i;
	BOOL bEnabled =  (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_REMOVETAG)== BST_CHECKED);	

	for (i = 0; i <6; i++)
	{	CheckDlgButton(hwndDlg, IDC_TAG_CHK_TITLE+i, (UINT)bEnabled ? BST_UNCHECKED : BST_CHECKED);  
		TagDlg_CheckTag2Edit(hwndDlg, IDC_TAG_CHK_TITLE+i);
	}

	EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_BTN_GO), TRUE);
}

/* ************************************************************************ */
void TagDlg_CheckTag2Edit(HWND hwndDlg, int nID)
{
	BOOL bEnabled;
	
	nID -= IDC_TAG_CHK_TITLE;

	bEnabled =  (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_TITLE + nID) == BST_CHECKED);	
	EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_EDIT_TITLE + nID), bEnabled);

	TagDlg_EnableGOButton(hwndDlg);
}

/* ************************************************************************ */
void TagDlg_EnableGOButton(HWND hwndDlg)
{
	BOOL bEnableGO = FALSE;
	int i;

	// if at least one item checked Enable button Go
	for (i = 0; i <6; i++)
	{	bEnableGO =  (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_TITLE + i) == BST_CHECKED);	
		if (bEnableGO)
			break;

	}
	EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_BTN_GO), bEnableGO);
}

/* ************************************************************************ */
void TagDlg_CheckTag2ListFrmt(HWND hwndDlg, int idx)
{
	int i,j, nCount;

	idx -= IDC_TAG_CHCKARTIST_FRMT;

	if (IsDlgButtonChecked(hwndDlg,IDC_TAG_CHCKARTIST_FRMT + idx))	
		SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_ADDSTRING, 0, (LPARAM)(LPSTR)listFrmt[idx]);
	else
	{
		char szTmp[40];
		nCount = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETCOUNT, 0, 0);

		for (i = 0; i < nCount; i++)
		{	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
			for (j = 0; j < 5; j++)
			{	if (strcmp(listFrmt[idx], szTmp)== 0)
				{
					SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_DELETESTRING, i, 0);	
					SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_SETCURSEL, --nCount, 0);
					return;
				}
			}	
		}

	}

}



/* ************************************************************** */
void  TagDlg_RemoveCol(HWND hwndDlg)
{	
	int i,j;
	char szTmp[40];

	i = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETCURSEL, 0, 0);

	if (i == LB_ERR) 
		return;

	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
	
	for (j = 0; j < 5; j++)
	{	if (strcmp(listFrmt[j], szTmp) == 0)
		{
			CheckDlgButton(hwndDlg,IDC_TAG_CHCKARTIST_FRMT + j, BST_UNCHECKED);
			SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_DELETESTRING, i, 0);	
			SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_SETCURSEL, i, 0);
			return;
		}
	}	
	
}



/* ************************************************************************ */
void TagDlg_UpdateFormat(HWND hwndDlg)
{
	int i, nCount, nLen;
	char szTmp[40];
	char szFormat[256];
	char *p;

	nCount = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT,  LB_GETCOUNT, 0, 0);

	szFormat[0] = '\0';

	for (i = 0; i <nCount; i++)
	{
		SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_GETTEXT, i, (LPARAM) (LPCTSTR)szTmp );
		strcat(szFormat, "<");
		strcat(szFormat, szTmp);
		strcat(szFormat, "> - ");
	}
	
	nLen = strlen(szFormat);
	
	// Remove  at the end " - "
	if (nLen > 0)
	{	p = szFormat + nLen - 3;
		*p = '\0';
	}
	
	// Update  format zone
	SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_FRMT), (LPSTR)szFormat);	

	// Enable GO Button if at least one item is selected
	EnableWindow(GetDlgItem(hwndDlg, IDC_TAG_BTN_GO), (nCount != 0) ? TRUE : FALSE);

}

/* ************************************************************************ */
void TagDlg_SelectAll(HWND hwndDlg, int nID)
{
	int i;
	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_RESETCONTENT, 0, 0);
	for (i = 0; i < 5; i++)
	{	
		CheckDlgButton(hwndDlg,IDC_TAG_CHCKARTIST_FRMT+i, nID == IDC_TAG_SELECTALL ? 
			BST_CHECKED : BST_UNCHECKED);	

		if (nID == IDC_TAG_SELECTALL)
			SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_ADDSTRING, 0, (LPARAM)(LPSTR)listFrmt[i]);		
	}
	SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FRMT, LB_SETCURSEL, 0, 0);
}


/* ************************************************************************ */
void TagDlg_EnableWriteButton(HWND hwndDlg, BOOL bEnabled)
{
	if (gnShowPart==2)
	{
		bChange = FALSE;
		return;
	}

	if (bIsLoading)
		bChange = FALSE;
	else
		bChange = bEnabled;

	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_BTN_WRITE), bChange);
}

/* ************************************************************************ */
void TagDlg_EnableLOG(HWND hwndDlg)
{
	BOOL bEnable;

	bEnable = (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_LOG)== BST_CHECKED);
	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_EDIT_LOG), bEnable);
	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_BTN_LOG), bEnable);
}

/* ************************************************************************ */
void TagDlg_BtnLOG(HWND hwndDlg)
{
	OPENFILENAME ofn; 
	char szDirName[256]; 
	char szFile[256];
	char szFileTitle[256]; 
    char szFilter[] = "ASCII file (*.txt)|Log file (*.log)|*.log|";
    
	SetFilter(szFilter);
	GetCurrentDirectory(sizeof(szDirName), (LPSTR)szDirName);
	*szFile = '\0'; 

	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = hwndDlg; 
	ofn.lpstrFilter = szFilter; 
	ofn.lpstrCustomFilter = (LPSTR) NULL; 
	ofn.nMaxCustFilter = 0L; 
	ofn.nFilterIndex = 0L; 
	ofn.lpstrFile = szFile; 
	ofn.nMaxFile = sizeof(szFile); 
	ofn.lpstrFileTitle = szFileTitle; 
	ofn.nMaxFileTitle = sizeof(szFileTitle); 
	ofn.lpstrInitialDir = szDirName; 
	ofn.lpstrTitle = (LPCSTR)"Choose trace log file"; 
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY; 
	ofn.nFileOffset = 0; 
	ofn.nFileExtension = 0; 
	ofn.lpstrDefExt = (LPSTR)NULL; 

	if (GetSaveFileName(&ofn)) 
	{ 
		if(ofn.nFilterIndex==1) 
			strcat(szFile, ".txt");	
		else
			strcat(szFile, ".log"); 
			
		SetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_LOG), (LPSTR)szFile);
	} 

}

/* ************************************************************************ */
void TagDlg_IsDirty(HWND hwndDlg)
{
	if (bChange == TRUE)
	{
		int ret = MessageBox(hwndDlg, "Write modifications ?", "Information Edit Tag", 
			MB_OKCANCEL | MB_ICONQUESTION );

		if (ret == IDOK)
			TagDlg_WriteTag(hwndDlg);
	}

	bChange = FALSE;
	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_BTN_WRITE), bChange);
}

/* ************************************************************************ */
void TagDlg_WriteTag(HWND hwndDlg)
{
	char szTemp[80];
	DWORD dwLen, dwIndex;
	MYITEM *pItem;
	ID3TAGSTRUCT id3tag;
	
	char title[31];
	char artist[31];
	char album[31];
	char year[5];
	char comment[31];
	unsigned char genre;
	
	// Save info Edit TAG from type user
	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETCURSEL, 0, 0);
	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETSEL, dwIndex, 0);

	if (dwIndex == 0 || dwIndex == LB_ERR)
	{	MessageBox(hwndDlg, "Select before a song", "Information Edit Tag", MB_OK | MB_ICONSTOP );
		TagDlg_EnableWriteButton(hwndDlg, FALSE);
		bChange = FALSE;
		return;
	}

	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETCURSEL, 0, 0);
	dwLen   = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)dwIndex, 0);
	if (dwLen == LB_ERR)
	{	MessageBox(hwndDlg, "Select before a song", "Information Edit Tag", MB_OK | MB_ICONSTOP );
		TagDlg_EnableWriteButton(hwndDlg, FALSE);
		bChange = FALSE;
		return;
	}

	pItem = (MYITEM*)dwLen;


	GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_TITLE), 
		(LPSTR)title, sizeof(title));
	GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ARTIST), 
		(LPSTR)artist, sizeof(artist));
	GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_ALBUM), 
		(LPSTR)album, sizeof(album));
	GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_YEAR), 
		(LPSTR)year, sizeof(year));
	GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_COMMENT), 
		(LPSTR)comment, sizeof(comment));

	dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_GETCURSEL, 0, 0);
	if (dwIndex == LB_ERR) 	
		genre = 255;
	else
	{	SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_GETLBTEXT  , (WPARAM)dwIndex, (LPARAM)((LPSTR) szTemp));
		genre = find_genre_id(szTemp);
	}

	// Set All bytes: space
	memset(&id3tag, 0x20, sizeof(id3tag));

	memcpy(id3tag.title, title, strlen(title));
	memcpy(id3tag.artist, artist, strlen(artist));
	memcpy(id3tag.album, album, strlen(album));
	memcpy(id3tag.year, year, strlen(year));
	memcpy(id3tag.comment, comment, strlen(comment));
	id3tag.genre = genre;
	if (id3tag.genre != 255) id3tag.genre--;


	if (id3tag_write(pItem->pFileName, &id3tag)== FALSE)
	{
		MessageBox(hwndDlg, "Can't write ID3 Tag !!!",  
			"Error", MB_OK | MB_ICONSTOP);	
		
		bChange = FALSE;		
		TagDlg_EnableWriteButton(hwndDlg, FALSE);
		return; 
	
	}

	// Save im memory	
	strcpy(pItem->pData->title, title);
	strcpy(pItem->pData->artist, artist);
	strcpy(pItem->pData->album, album);
	strcpy(pItem->pData->year, year);
	strcpy(pItem->pData->comment, comment);
	pItem->pData->genre = genre;

	// Set the new title for playlist
	GlobalFree(pItem->pData->titleplaylist);
	pItem->pData->titleplaylist = DupString(pItem->pData->artist);
	
	TagDlg_EnableWriteButton(hwndDlg, FALSE);
}

/* ************************************************************************ */
void TagDlg_BtnGO(HWND hwndDlg)
{
	HCURSOR hcurOld;
	int i, nCount;
	HLOCAL hMem  = NULL;
	int *pArray = NULL;
	FILE *filelog = NULL;
	BOOL bOK, bSelected, bRemoveTAG, bLog;
	const char *Msg_label[] = {"Failed", "Success"};
	char szMsg[40];

	
	TagDlg_SaveParam(hwndDlg);

	bSelected  = (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_ONLYSELECTED)== BST_CHECKED);
	bRemoveTAG = (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_REMOVETAG)== BST_CHECKED);
	bLog       = (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_LOG)== BST_CHECKED);
	
	
	if (bLog)
	{
		char szFileLog[MAX_PATH];
		szFileLog[0] = '\0';
		GetWindowText(GetDlgItem(hwndDlg, IDC_TAG_EDIT_LOG), (LPSTR)szFileLog, sizeof(szFileLog));
		
		if (strlen(szFileLog) == 0)
		{	MessageBox(hwndDlg, "Choose a log file !!!", "Error", MB_OK | MB_ICONSTOP);
			return;
		}
		if ((filelog = fopen(szFileLog, "w+t")) == NULL)
		{	MessageBox(hwndDlg, "Error log file !!!", "Error", MB_OK | MB_ICONSTOP);
			return;
		}
	}

	if (!bSelected)
	{	// Item to Mass set tag or Remove
		nCount = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETCOUNT, 0, 0);
	}
	else
	{	// Only selected item to Mass set Tag or Remove
		nCount = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETSELCOUNT, 0, 0);
		if (nCount == LB_ERR || nCount == 0)
		{	MessageBox(hwndDlg, "At least 1 file must be selected !!!", "Error", MB_OK | MB_ICONSTOP);
			return; 
		}
	
		hMem = LocalAlloc(LPTR, nCount);
		pArray = (int*)LocalLock(hMem);
		SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETSELITEMS, (WPARAM)nCount, (LPARAM)pArray);
	}
	

	if (bLog)
	{
		switch(gnShowPart)
		{
		case 2: 
			if (bRemoveTAG)
				fprintf(filelog, "Remove TAG %d files (Trace LOG)\nEZPlaylist for Winamp\n\n", nCount);
			else
				fprintf(filelog, "Mass set TAG %d files (Trace LOG)\nEZPlaylist for Winamp\n\n", nCount);
			break;
		case 4: 
			fprintf(filelog, "Rename %d files from ID3Tag (Trace LOG)\nEZPlaylist for Winamp\n\n", nCount);
			break;
		case 8: 
			fprintf(filelog, "Write ID3Tag from %d files (Trace LOG)\nEZPlaylist for Winamp\n\n", nCount);
			break;
		}

		fprintf(filelog, "----------------------\nDate: %s\n\n", GetFormattedDateTime());
	}

	hcurOld = SetCursor(LoadCursor(NULL, IDC_WAIT));
	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_BTN_GO), FALSE);

	// Scan file item	
	for (i = 0; i<nCount; i++)
	{
		bOK = FALSE;

		switch(gnShowPart)
		{
		case 2: 
			bOK = TagDlg_MassTAG(hwndDlg, bSelected ? pArray[i] : i, bRemoveTAG);
			break;
		case 4: 
			bOK =  TagDlg_RenameFileFromTAG(hwndDlg, bSelected ? pArray[i] : i);
			break;
		case 8: 
			bOK = TagDlg_WriteTAGFromFile(hwndDlg, bSelected ? pArray[i] : i);
			break;
		}
		
		if (bLog)
		{
			DWORD dwLen;
			MYITEM *pItem;

			dwLen   = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)(bSelected ? pArray[i] : i), 0);
			pItem = (MYITEM*)dwLen;
			fprintf(filelog, "file%d=(%s): %s\n", i+1, Msg_label[bOK], pItem->pFileName);	
		}
		
	}
	
	EnableWindow(GetDlgItem(hwndDlg,IDC_TAG_BTN_GO), TRUE);
	SetCursor(hcurOld);

	if (bSelected)
	{
		LocalUnlock(hMem);
		LocalFree(hMem);
	}
	if (bLog)
		fclose(filelog);

	// Show resume action in MsgBox
	switch(gnShowPart)
	{
		case 2:	if (bRemoveTAG)
				sprintf(szMsg, "Remove ID3TAG on %d file(s)", nCount);
			else
				sprintf(szMsg, "Mass set ID3TAG on %d file(s)", nCount);
			break;
		case 4:
			sprintf(szMsg, "Write filename from ID3TAG on %d file(s)", nCount);
			break;
		case 8:
			sprintf(szMsg, "Write ID3TAG from filename on %d file(s)", nCount);
			break;
	}
	MessageBox(hwndDlg, szMsg, "Information", MB_OK | MB_ICONINFORMATION);


	if(gnShowPart==4)
		TagDlg_InitFileList(hwndDlg);
	
}


/* ************************************************************************ */
BOOL TagDlg_MassTAG(HWND hwndDlg, int iItem, BOOL bRemoveTAG)
{
	DWORD dwLen, dwIndex;
	MYITEM *pItem;

	dwLen   = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)iItem, 0);
	pItem = (MYITEM*)dwLen;
	
	if (bRemoveTAG)
	{
		id3tag_remove(pItem->pFileName); 

		// Clear in Playlist item in memory
		pItem->pData->title[0] = '\0';
		pItem->pData->artist[0] = '\0';
		pItem->pData->album[0] = '\0';
		pItem->pData->comment[0] = '\0';
		pItem->pData->year[0] = '\0';
		pItem->pData->genre = 255;

		return TRUE;
	}
	else
	{
		ID3TAGSTRUCT id3tag;
		char title[31];
		char artist[31];
		char album[31];
		char year[5];
		char comment[31];
		unsigned char genre;
		
		// Read Existing TAG in filename
		if (id3tag_read(pItem->pFileName, &id3tag) == FALSE) 
			memset(&id3tag, 0x20, sizeof(id3tag));		// set 0 for none TAG

#define SETTAG(chk, edt, p, tag)						\
	if (IsDlgButtonChecked(hwndDlg, chk)== BST_CHECKED)	\
	{	GetWindowText(GetDlgItem(hwndDlg, edt),			\
			(LPSTR)p, sizeof(p));						\
		memset(tag, 0x20, sizeof(tag));					\
		memcpy(tag, p, strlen(p));						\
	}													\

	SETTAG(IDC_TAG_CHK_TITLE, IDC_TAG_EDIT_TITLE, title, id3tag.title);
	SETTAG(IDC_TAG_CHK_ARTIST, IDC_TAG_EDIT_ARTIST, artist, id3tag.artist);
	SETTAG(IDC_TAG_CHK_ALBUM, IDC_TAG_EDIT_ALBUM, album, id3tag.album);
	SETTAG(IDC_TAG_CHK_YEAR, IDC_TAG_EDIT_YEAR, year, id3tag.year);
	SETTAG(IDC_TAG_CHK_COMMENT, IDC_TAG_EDIT_COMMENT, comment, id3tag.comment);

#undef SETTAG

		// Genre
		dwIndex = SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_GETCURSEL, 0, 0);
		if (dwIndex == LB_ERR) 	
			genre = 255;	// undefined genre
		else
		{	char szTemp[80];
			SendDlgItemMessage(hwndDlg, IDC_TAG_EDIT_GENRE,  CB_GETLBTEXT  , (WPARAM)dwIndex, (LPARAM)((LPSTR) szTemp));
			genre = find_genre_id(szTemp);
		}
		id3tag.genre = genre;
		if (id3tag.genre != 255) id3tag.genre--;
		

		// Write the new TAG
		if(id3tag_write(pItem->pFileName, &id3tag) == FALSE)
			return FALSE;

		// Save in memory modify
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_TITLE)== BST_CHECKED)
			strcpy(pItem->pData->title, title);
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_ARTIST)== BST_CHECKED)
			strcpy(pItem->pData->artist, artist);
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_ALBUM)== BST_CHECKED)
			strcpy(pItem->pData->album, album);
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_YEAR)== BST_CHECKED)
			strcpy(pItem->pData->year, year);
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_COMMENT)== BST_CHECKED)
			strcpy(pItem->pData->comment, comment);
		if (IsDlgButtonChecked(hwndDlg, IDC_TAG_CHK_GENRE)== BST_CHECKED)
			pItem->pData->genre = genre;

		return TRUE;
	}

}

/* ************************************************************************ */
BOOL TagDlg_RenameFileFromTAG(HWND hwndDlg, int iItem)
{
	ID3TAGSTRUCT id3;
	DWORD dwLen;
	int nLen, i, nColFrmt ;
	MYITEM *pItem;
	char szFormat[1024];
	char szOutputFile[1024];
	char *p, *pStart, *pEnd;
	size_t size;

	// Save info Edit TAG from type user
	dwLen   = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)iItem, 0);
	pItem = (MYITEM*)dwLen;

	// if file did not contain tag exit !!!
	if (id3tag_read(pItem->pFileName, &id3) == FALSE)
		return FALSE;

	szOutputFile[0] = '\0';
	szFormat[0] = '\0';
	nLen = 0;
	
	nColFrmt = SendDlgItemMessage(hwndDlg,IDC_TAG_LIST_FRMT,LB_GETCOUNT,0,0);
	
	for (i = 0; i < nColFrmt; i++)
	{
		switch(gParam.FrmtCol[i])
		{
		case 0:	
			if (strlen(pItem->pData->artist)==0)
				strcat(szFormat, "Unkown artist");
			else	
				strcat(szFormat, pItem->pData->artist);
			break;
		case 1:	
			if (strlen(pItem->pData->title)==0)
				strcat(szFormat, "Untitled");
			else	
				strcat(szFormat, pItem->pData->title);
			break;
		case 2:	
			if (strlen(pItem->pData->album)==0)
				strcat(szFormat, "Unkown album");
			else	
				strcat(szFormat, pItem->pData->album);
			break;
		case 3:	strcat(szFormat, pItem->pData->year);
			break;
		case 4:	strcat(szFormat, pItem->pData->comment);
			break;
		}

		strcat(szFormat, " - ");
	}

	nLen = strlen(szFormat);
	
	// Remove  at the end " - "
	if (nLen > 0)
	{	p = szFormat + nLen - 3;
		*p= '\0';
	}

	pEnd = strrchr(pItem->pFileName, '\\');
	pStart = pItem->pFileName;
	size = pEnd - pStart;
	
	if (size)
	{
		// Copy path
		memcpy(szOutputFile, pItem->pFileName,  size);
		p= szOutputFile + size;
		*p = '\0';

		// copy new filename
		strcat(szOutputFile, "\\");
		strcat(szOutputFile, szFormat);
		strcat(szOutputFile, ".mp3");
	}
	else
		sprintf(szOutputFile, "%s.mp3",szFormat);
		

	// Rename MP3 file
	if (MoveFile((LPTSTR)pItem->pFileName, (LPTSTR)szOutputFile))
	{
		// OK change in memory the new filename
		GlobalFree(pItem->pFileName);
		pItem->pFileName = DupString(szOutputFile);
		return TRUE;
	}
	else
		return FALSE;
}



/* ************************************************************************ */
BOOL TagDlg_WriteTAGFromFile(HWND hwndDlg, int iItem)
{
	DWORD dwLen;
	MYITEM *pItem;
	int nToken;
	int nByte; 
	ID3TAGSTRUCT id3tag;
	char szTemp[1024];
	BOOL bExist = TRUE;
	char *p;
	char *sep = " - ";
	char *pSep;
	int size;
	int nAddressLength;
	int nCurrentAddress = 0;

	// Save info Edit TAG from parser filename
	dwLen = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETTEXT , (WPARAM)iItem, (LPARAM)(LPCTSTR)szTemp);
	dwLen = SendDlgItemMessage(hwndDlg, IDC_TAG_LIST_FILE,  LB_GETITEMDATA , (WPARAM)iItem, 0);
	pItem = (MYITEM*)dwLen;

	memset(&id3tag, 0x20, sizeof(id3tag));		// set 0 for none TAG
	id3tag.genre = 255;

	// Remove  extension '.mp3'
	nAddressLength = strlen(szTemp);
	nAddressLength -= 4,
	szTemp[nAddressLength] = '\0';

	nToken = 0;

	while(nCurrentAddress < nAddressLength)
	{
		// find the next separator
		pSep = strstr(&szTemp[nCurrentAddress], sep);

		if (pSep==NULL)
		{	// no found separator
			size = strlen(&szTemp[nCurrentAddress]);
			p = &szTemp[nCurrentAddress];
			nCurrentAddress = nAddressLength; // force exit while
		}
		else
		{	// separator found
			p = &szTemp[nCurrentAddress];
			size = pSep - p;
		}

		nByte = (size < 30 ? size : 30);

		switch(gParam.FrmtCol[nToken])
		{
			case 0:	
				memcpy(id3tag.artist, p, nByte);
				break;
			case 1:	memcpy(id3tag.title, p, nByte);
				break;
			case 2:	memcpy(id3tag.album, p , nByte);
				break;
			case 3:	
				nByte = (size < 4 ? size : 4);
				memcpy(id3tag.year, p, nByte);
				break;
			case 4:	
				memcpy(id3tag.comment, p , nByte);
				break;
		}

		// Increment the address for next iteration. 
		nCurrentAddress += size + strlen(sep); 
		
		nToken++;		
	}

	
	// Write in TAG
	if (id3tag_write(pItem->pFileName, &id3tag) == FALSE)
		return FALSE;			

	// Save im memory	
	mpg123_copytag(pItem->pData->title, id3tag.title, 30);
	mpg123_copytag(pItem->pData->artist,id3tag.artist, 30);
	mpg123_copytag(pItem->pData->album, id3tag.album, 30);
	mpg123_copytag(pItem->pData->year, id3tag.year, 4);
	mpg123_copytag(pItem->pData->comment, id3tag.comment, 30);	
	pItem->pData->genre = (id3tag.genre != 255 ? id3tag.genre+1 : 255);

	// Set the new title for playlist
	GlobalFree(pItem->pData->titleplaylist);
	pItem->pData->titleplaylist = DupString(pItem->pData->artist);	

	return TRUE;			
}


