#include <windows.h>
#include <shlobj.h>    // SHBrowseForFolder  		
#include <winuser.h>   // GetClassLong
#include <commctrl.h>
#include <stdio.h>
#include <mmsystem.h> 	// winmm.lib.

#include "gen.h"
#include "status.h"
#include "DlgColumn.h"
#include "EZPlayList.h"
#include "DlgTag.h"
#include "ID3TAG.h"
#include "resource.h"


// external declaration
extern int gnShowPart;
extern winampGeneralPurposePlugin plugin;
extern PLAYLISTSTRUCT gPlayList;
extern char szAppName[];
extern gbOpenDlg;
extern HWND m_hwndStat;
extern STATGENRESTRUCT gStatGenre[MAX_GENRE];
extern BOOL bColumnsChange;
extern BOOL bFilterChange;


MYITEM *gpStartItem = NULL;
MYITEM *gpEndItem = NULL;

COLUMNSSTRUCT gCol[MAX_COL]=
{	{"Artist", 120, LVCFMT_LEFT},		
	{"Title", 160, LVCFMT_LEFT},
	{"Genre", 85, LVCFMT_LEFT},
	{"Year", 45, LVCFMT_LEFT},
	{"Album", 160, LVCFMT_LEFT},
	{"Comment", 160, LVCFMT_LEFT},
	{"Mode", 75, LVCFMT_LEFT},
	{"Bitrate", 70, LVCFMT_RIGHT},
	{"Freq.", 70, LVCFMT_LEFT},
	{"Layer", 100, LVCFMT_LEFT},
	{"Time", 40, LVCFMT_RIGHT},
	{"Size", 80, LVCFMT_RIGHT},
	{"File name", 400, LVCFMT_LEFT},
};

INITSTRUCT gParam;
HWND m_hwndList = NULL;
static int nOldSortColumn = 0;
static BOOL bSortOrderAscanding = TRUE;
static BOOL bShowDuplicate = FALSE;
static int bSelectSame = -1;
static long nTotalLength;
static long nAvgLength;

enum { COMDLG_OPEN = 0, COMDLG_SAVE};


// internal functions
LRESULT CALLBACK MainMessageProc(int nCode, WPARAM wParam, LPARAM lParam);
void PlaylistDlg_init(HWND hWndDlg);
void PlaylistDlg_Resize(HWND hwndDlg, LPARAM lParam);
LRESULT PlaylistDlg_NotifyHandler( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, HINSTANCE hInst);
int CALLBACK PlaylistDlg_ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
BOOL PlaylistDlg_doContextMenu(HWND hWnd, WPARAM wParam, LPARAM lParam);
void PlaylistDlg_UpdateMenu(HWND hwndListView, HMENU hMenu); 
void PlaylistDlg_MenuButton(HWND hwndDlg, int nButton);				
void PlaylistDlg_MenuCheckItem(int nItem);				
void PlaylistDlg_OwnerDrawBtn (LPDRAWITEMSTRUCT lpdis);
void PlaylistDlg_doScrollSlider(HWND hWnd, HWND hSlider); 
void  PlaylistDlg_SetActive(HWND hwndDlg);
void PlaylistDlg_LoadParam(void);
void PlaylistDlg_SaveParam(void);
static int CALLBACK myBrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
void LV_AddFiles(HWND hwndDlg);
void LV_AddDirectory(HWND hwndDlg);
void LV_AddDir2List(char* dir);
void LV_New(HWND hwndDlg);
void LV_ComDlg(HWND hwndDlg, int OPENSAVE);
void LV_Import(HWND hwndDlg);
void LV_Export(HWND hwndDlg);
void LV_Playlist(HWND hWndDlg, int);
void LV_PlaylistWinamp(HWND hWndDlg, int);
void LV_LoadEZ3(char *filename, HWND hWndDlg);
void LV_LoadM3U(char *filename, HWND hWndDlg);
void LV_LoadPLS(char *filename, HWND hwndDlg);
void LV_WriteEZ3(char*);
BOOL LV_WriteM3U(char*);
BOOL LV_WritePLS(char*);
BOOL LV_WriteHTML_Table(char*);
BOOL LV_WriteHTML_Listing(char*);
BOOL LV_WriteASCII(char*);
void LV_InitColumns(HWND hWndDlg);
void LV_SelectAll(BOOL bSelect);
void LV_SelectToggle(void);
void LV_SelectWithSame(int nCol);
void LV_SelectCrop(void);
void LV_SelectDel(void);
void LV_UpdateStatus(void);
void LV_StatGenre(void);
void LV_UpdatePlaylist(HWND hwndDlg);
void LV_ShowDuplicate(void);
void LV_DeadFiles(void);
void LV_Redraw(BOOL bUpdate);
void LV_GetInfoCol(MYITEM *, int col, char *szCol);

void winamp_enqueue_to_playlist(BOOL bPlay);
void winamp_enqueue_all_to_playlist(BOOL bPlay);

MYITEM * Item_New(MYITEM *pLast, LPSTR lpszFileName);
MYITEM * Item_Delete(MYITEM *pDel);
int Item_DeleteAll(void);
MYITEM* Item_GetLast(void);

void UpdateStatus(HWND hDlg);
long GetVolume(void);

/* ************************************************************************ */


BOOL CALLBACK PlaylistDlg_Proc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_INITDIALOG:
			gbOpenDlg = TRUE;
			PlaylistDlg_LoadParam();
			PlaylistDlg_init(hwndDlg);
			return FALSE;
		
	/*	case WM_GETMINMAXINFO: 
			// limit minimum size of the main window 
			((MINMAXINFO FAR*)lParam)->ptMinTrackSize.x =  450;
			((MINMAXINFO FAR*)lParam)->ptMinTrackSize.y = 180; 
			return TRUE;
*/
		case WM_CLOSE:
		    DestroyWindow (hwndDlg);
	        return 0;

		case WM_DESTROY :
			gbOpenDlg = FALSE;
			PlaylistDlg_SaveParam();
			LV_Playlist(hwndDlg, COMDLG_SAVE);
			ListView_DeleteAllItems(m_hwndList); 
			Item_DeleteAll();
			PostQuitMessage (0);
			return TRUE;

		case WM_DRAWITEM:
	        PlaylistDlg_OwnerDrawBtn((LPDRAWITEMSTRUCT)lParam);		
			return TRUE;

	   case WM_CONTEXTMENU: 
			if(PlaylistDlg_doContextMenu(hwndDlg, wParam, lParam)) 
				return FALSE; 
			break; 

		case WM_SIZE:
			PlaylistDlg_Resize(hwndDlg, lParam);
			return TRUE;
		
		case WM_HSCROLL:
			PlaylistDlg_doScrollSlider(hwndDlg, (HWND)lParam);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case ID_FILE_QUIT:
			case IDK_QUIT:
				DestroyWindow (hwndDlg);
				return TRUE;
			case ID_OPTION_OPTION:
			case IDK_OPTION:
				DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGOPTION), hwndDlg, (DLGPROC)OptionDlg_Proc);
				PlaylistDlg_SetActive(hwndDlg);
				return TRUE;
			case ID_OPTION_CONFIGURE:
			case IDK_CONFIGURE:
				DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGCONFIGURE),hwndDlg,(DLGPROC)ConfigProc);
				return TRUE;
			case ID_OPTION_FILTER:
			case IDK_FILTER:
				DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGFILTER),hwndDlg,(DLGPROC)FilterDlg_Proc);
				PlaylistDlg_SetActive(hwndDlg);
				return TRUE;
			
			case ID_ID3TAG_EDITID3TAG:
			case ID_ID3TAG_MASSSETID3:
			case ID_ID3TAG_RENAMEFILEFROMID3:
			case ID_ID3TAG_WRITEID3FROMFILE:
				gnShowPart =  1 << (LOWORD(wParam) - ID_ID3TAG_EDITID3TAG);
				DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGTAG),hwndDlg,(DLGPROC)TagDlg_Proc);
				PlaylistDlg_SetActive(hwndDlg);
				return TRUE;
			
			case ID__ABOUT:
			case IDK_ABOUTHELP:
				DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGABOUT),hwndDlg,(DLGPROC)AboutDlg_Proc);
				return TRUE;

			case IDC_BUTTON_FILE:
			case IDC_BUTTON_ADD:
			case IDC_BUTTON_OPTION:
				PlaylistDlg_MenuButton(hwndDlg, LOWORD(wParam));				
				return FALSE;

			case ID_SEARCH_ARTIST:
			case ID_SEARCH_TITLE:
			case ID_SEARCH_ALBUM:
			case ID_SEARCH_COMMENT:
			case ID_SEARCH_FILENAME:
				PlaylistDlg_MenuCheckItem(LOWORD(wParam)-ID_SEARCH_ARTIST);				
				LV_UpdatePlaylist(hwndDlg);
				return FALSE;

			case IDK_FIND:
				SetFocus(GetDlgItem(hwndDlg, IDC_EDIT_SEARCH));
				return TRUE;

			case IDC_EDIT_SEARCH:
				if (HIWORD(wParam) == EN_UPDATE)
					LV_UpdatePlaylist(hwndDlg);
				return TRUE;

			case IDK_SEARCH_ARTIST:
			case IDK_SEARCH_TITLE:
			case IDK_SEARCH_ALBUM:
			case IDK_SEARCH_COMMENT:
			case IDK_SEARCH_FILENAME:
				PlaylistDlg_MenuCheckItem(LOWORD(wParam)-IDK_SEARCH_ARTIST);				
				return FALSE;
			
			case ID_FILENEW:
			case IDK_NEW:
				LV_New(hwndDlg);
				return FALSE;

			case ID_FILEOPEN:
			case IDK_OPEN:
				LV_ComDlg(hwndDlg, COMDLG_OPEN);
				return FALSE;
			
			case ID_FILESAVE:
			case ID_FILESAVEAS:
			case IDK_SAVE:
				LV_ComDlg(hwndDlg, COMDLG_SAVE);
				return FALSE;
			
			case ID_FILEIMPORT:
				LV_Import(hwndDlg);
				return FALSE;

			case ID_FILEEXPORT:
				LV_Export(hwndDlg);
				return FALSE;

			case ID_ADD_ADDFILES:
			case IDK_ADDFILES:
				LV_AddFiles(hwndDlg);
				return FALSE;

			case ID_ADD_ADDDIRECTORY:
			case IDK_ADDDIRECTORY:
				LV_AddDirectory(hwndDlg);
				return FALSE;

			case ID_PLAYLIST_PLAY:
			case IDK_PLAY:
				winamp_enqueue_to_playlist(TRUE);
				return FALSE;

			case ID_PLAYLIST_PLAYALL:
				winamp_enqueue_all_to_playlist(TRUE);
				return FALSE;

			case ID_PLAYLIST_ENQUEUE:
				winamp_enqueue_to_playlist(FALSE);
				return FALSE;

			case ID_PLAYLIST_ENQUEUEALL:
				winamp_enqueue_all_to_playlist(FALSE);
				return FALSE;

			case ID_PLAYLIST_SHOWHIDEPLAYLIST:
				SendMessage(plugin.hwndParent, WM_COMMAND, (WPARAM)40040,0);
				return FALSE;

			case ID_PLAYLIST_CLEARCURRENTPLAYLIST:
				SendMessage(plugin.hwndParent, WM_USER, (WPARAM)NULL, 101);
				return FALSE;

			case ID_PLAYLIST_SELECTALL:
			case IDK_SELECTALL:
				LV_SelectAll(TRUE);
				return FALSE;

			case ID_PLAYLIST_SELECTNONE:
				LV_SelectAll(FALSE);
				return FALSE;

			case ID_PLAYLIST_SELECTTOGGLE:
			case IDK_SELECTTOGGLE:
				LV_SelectToggle();
				return FALSE;

			case ID_PLAYLIST_SELECTWITHSAME_ARTIST: 
			case ID_PLAYLIST_SELECTWITHSAME_TITLE:  
			case ID_PLAYLIST_SELECTWITHSAME_GENRE:  
			case ID_PLAYLIST_SELECTWITHSAME_YEAR:   
			case ID_PLAYLIST_SELECTWITHSAME_ALBUM:  
			case ID_PLAYLIST_SELECTWITHSAME_COMMENT:
			case ID_PLAYLIST_SELECTWITHSAME_MODE:   
			case ID_PLAYLIST_SELECTWITHSAME_BITRATE:
			case ID_PLAYLIST_SELECTWITHSAME_FREQSAMPLING:
			case ID_PLAYLIST_SELECTWITHSAME_LAYER:
			case ID_PLAYLIST_SELECTWITHSAME_TIME:
			case ID_PLAYLIST_SELECTWITHSAME_FILESIZE:
			case ID_PLAYLIST_SELECTWITHSAME_FILENAME:
				{
				int nCol = LOWORD(wParam)-ID_PLAYLIST_SELECTWITHSAME_ARTIST;
				LV_SelectWithSame(nCol);
				}
				return FALSE;

			case ID_PLAYLIST_SELECTCROP:
			case IDK_CROP:
				LV_SelectCrop();
				return FALSE;

			case ID_PLAYLIST_DEL:
			case IDK_DEL:
				LV_SelectDel();
				return FALSE;

			case ID_PLAYLIST_SELECTALLDEADFILES:
				LV_DeadFiles();
				return FALSE;

			case ID_PLAYLIST_SHOWDUPLICATE:
				bShowDuplicate = !bShowDuplicate; 
				if (bShowDuplicate)
					LV_ShowDuplicate();
				else
					LV_UpdatePlaylist(hwndDlg);
				return FALSE;

			default:
				return FALSE;
			}
			
		case WM_NOTIFY:
			PlaylistDlg_NotifyHandler(hwndDlg, uMsg, wParam, lParam, plugin.hDllInstance);
			break;

	}
	return FALSE;
}




/****************************************************************************
* 
*    FUNCTION: EZDlg_NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the list view window.
*
****************************************************************************/
LRESULT PlaylistDlg_NotifyHandler( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam,
	HINSTANCE hInst)
{
	LV_DISPINFO FAR * pnmv = (LV_DISPINFO FAR *) lParam;
	NM_LISTVIEW *pNm = (NM_LISTVIEW *)lParam;
	
	//if (wParam != IDC_LVW_PLAYLIST)		return 0L;

	switch(((LPNMHDR) lParam)->code)
	{
	/*	
	case PSN_SETACTIVE: 
			if (bColumnsChange == TRUE)
			{
				// Remove old columns
				int i;
				for (i = 0; i < gParam.NbCol; i++)
					ListView_DeleteColumn (m_hwndList, 0);							

				// Calculate used columns
				for (gParam.NbCol = 0, i = 0; i < MAX_COL; i++)
					if (gParam.UseCol[i] != -1) 
					gParam.NbCol++;

				LV_InitColumns(hwndDlg);					
			}

			if (bFilterChange == TRUE)
				LV_UpdatePlaylist(hwndDlg);
			return(TRUE); 

		case PSN_KILLACTIVE:	

			return TRUE;

		case PSN_APPLY:
			{
				int nOldSetting = gParam.bExportAllItems;
				gParam.bExportAllItems = 0;
				
				LV_PlaylistWinamp(hwndDlg, COMDLG_SAVE);
				
				gParam.bExportAllItems = nOldSetting;
			}
			return(TRUE); 

		case PSN_RESET:
			return(TRUE); 
*/
		// listview
        case NM_DBLCLK: 
		case NM_RETURN: 
			switch (gParam.nDblClic)
			{
			case 0:	winamp_enqueue_to_playlist(TRUE); break;
			case 1:	winamp_enqueue_to_playlist(FALSE); break;
			}

			return(TRUE); 
			
		case LVN_GETDISPINFO:
			// Provide the item or subitem's text, if requested. 
		    if (pnmv->item.mask & LVIF_TEXT) 
			{ 
				char szCol[256];
				MYITEM *pItem = (MYITEM *) (pnmv->item.lParam); 

				LV_GetInfoCol(pItem, pnmv->item.iSubItem, szCol) ;
				lstrcpy(pnmv->item.pszText, (LPSTR)szCol);
			}
			break;


		case LVN_COLUMNCLICK:
			if (nOldSortColumn == pNm->iSubItem)
				bSortOrderAscanding = !bSortOrderAscanding;

			nOldSortColumn = pNm->iSubItem;
			ListView_SortItems( pNm->hdr.hwndFrom, PlaylistDlg_ListViewCompareProc,
								(LPARAM)(pNm->iSubItem));
			break;

		default:
			break;
	}
	return 0L;
}


/**************************************************************************** */
int CALLBACK PlaylistDlg_ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{     
	MYITEM *pItem1 = (MYITEM *) lParam1; 
    MYITEM *pItem2 = (MYITEM *) lParam2;      
	int iCmp; 

	// Compare the specified column. 
	switch(gParam.UseCol[lParamSort])
	{
		case 0:
			iCmp = lstrcmpi(pItem1->pData->titleplaylist , pItem2->pData->titleplaylist);
			break;
		case 1:
			iCmp = lstrcmpi(pItem1->pData->title, pItem2->pData->title);
			break;
		case 2:
			iCmp = lstrcmpi(
						(LPSTR)get_id3_genre(pItem1->pData->genre), 
						(LPSTR)get_id3_genre(pItem2->pData->genre));
			break;
		case 3:
			iCmp = lstrcmpi(pItem1->pData->year, pItem2->pData->year);
			break;
		case 4:
			iCmp = lstrcmpi(pItem1->pData->album, pItem2->pData->album);
			break;
		case 5:
			iCmp = lstrcmpi(pItem1->pData->comment, pItem2->pData->comment);
			break;
		case 6:
			iCmp = lstrcmpi(
						(LPSTR)get_mode(pItem1->pData->mode), 
						(LPSTR)get_mode(pItem2->pData->mode));
			break;
		case 7:
			if (pItem1->pData->bitrate == pItem2->pData->bitrate)
				iCmp = 0;
			else if (pItem1->pData->bitrate > pItem2->pData->bitrate)
				iCmp = 1;
			else
				iCmp = -1;
			break;
		case 8:
			if (pItem1->pData->frequency == pItem2->pData->frequency)
				iCmp = 0;
			else if (pItem1->pData->frequency > pItem2->pData->frequency)
				iCmp = 1;
			else
				iCmp = -1;
		
		case 9:
			{
				char szTmp1[40], szTmp2[40];
				get_layer_mode(pItem1->pData, szTmp1);
				get_layer_mode(pItem2->pData, szTmp2);
				iCmp = strcmpi(szTmp1, szTmp2);
				break;
			}
		case 10:
			if (pItem1->pData->length == pItem2->pData->length)
				iCmp = 0;
			else if (pItem1->pData->length > pItem2->pData->length)
				iCmp = 1;
			else
				iCmp = -1;
			break;

		case 11:
			if (pItem1->pData->filesize == pItem2->pData->filesize)
				iCmp = 0;
			else if (pItem1->pData->filesize > pItem2->pData->filesize)
				iCmp = 1;
			else
				iCmp = -1;
			break;

		case 12:
			iCmp = lstrcmpi(pItem1->pFileName, pItem2->pFileName);
			break;

	}

	if (!bSortOrderAscanding)
		iCmp *= -1;
	
	return (iCmp); 
}

/* ************************************************************ */
void LV_GetInfoCol(MYITEM *pItem, int col, char *szCol) 
{

	switch(gParam.UseCol[col])
	{
	case 0:
		lstrcpy(szCol, (LPSTR)pItem->pData->titleplaylist);
		break;
	case 1:
		lstrcpy(szCol, (LPSTR)pItem->pData->title);
		break;
	case 2:
		lstrcpy(szCol, (LPSTR)get_id3_genre(pItem->pData->genre));
		break;
	case 3:
		lstrcpy(szCol, (LPSTR)pItem->pData->year);
		break;
	case 4:
		lstrcpy(szCol, (LPSTR)pItem->pData->album);
		break;
	case 5:
		lstrcpy(szCol, (LPSTR)pItem->pData->comment);
		break;
	case 6:
		lstrcpy(szCol, (LPSTR)get_mode(pItem->pData->mode));
		break;
	case 7:
		wsprintf(szCol, "%d kbps", pItem->pData->bitrate);
		break;
	case 8:
		wsprintf(szCol, "%d khz", pItem->pData->frequency);
		break;
	case 9:
		get_layer_mode(pItem->pData, szCol);
		break;
	case 10:
		lstrcpy(szCol, (LPSTR)pItem->pData->lengthfmt);
		break;
	case 11:
		wsprintf(szCol, "%u ", pItem->pData->filesize);
		break;
	case 12:
		lstrcpy(szCol, (LPSTR)pItem->pFileName);
		break;
	default:
		lstrcpy(szCol, (LPSTR)"Nothing");
		break;
	}
}

/* ****************************************************************** */
void PlaylistDlg_Resize(HWND hwndDlg, LPARAM lParam)
{
	RECT rc;
	WORD wWidth  = LOWORD(lParam);  
	WORD wHeight = HIWORD(lParam); 
	int hStatus;
	int hEdit;
	HWND hwndEdit;
	POINT pt;
	
	hwndEdit = GetDlgItem(hwndDlg, IDC_EDIT_SEARCH);
	GetClientRect(hwndEdit, &rc);
	hEdit  = (rc.bottom - rc.top) + 20;

	GetClientRect(m_hwndStat, &rc);
	hStatus = rc.bottom - rc.top;
	
	MoveWindow(GetDlgItem(hwndDlg, IDC_LVW_PLAYLIST), 0, hEdit, wWidth , wHeight - hEdit - hStatus, TRUE); 
	MoveWindow(m_hwndStat, 0, wHeight - hStatus, wWidth, hStatus, TRUE);


	hwndEdit = GetDlgItem(hwndDlg, IDC_SLIDER_VOLUME);
	GetWindowRect(hwndEdit, &rc);
	
	pt.x = rc.left;
	pt.y = rc.top;
	ScreenToClient(hwndDlg, &pt);
	wWidth = wWidth -  pt.x  - 4;

	if (wWidth > 0)
		MoveWindow(hwndEdit, pt.x, pt.y, wWidth, rc.bottom - rc.top, TRUE);

}

/* ************************************************************************ */
void PlaylistDlg_init(HWND hWndDlg)
{
	LPARAM lParam;
	RECT rect;	
	HWND hWndSlider;
	long nVol;
	HCURSOR hcurOld = SetCursor(LoadCursor(NULL, IDC_WAIT));


	// Initialize Volume to 45%
	hWndSlider = GetDlgItem(hWndDlg, IDC_SLIDER_VOLUME);
	SendMessage( hWndSlider, TBM_SETRANGE, TRUE, MAKELONG(0,255));
	nVol = GetVolume();

	SendMessage( hWndSlider, TBM_SETPOS, TRUE, nVol);
	SendMessage( hWndSlider, TBM_SETPAGESIZE, 0L, 50L);
	SendMessage( hWndSlider, TBM_SETLINESIZE, 0L, 10L);
	PlaylistDlg_doScrollSlider(hWndDlg, hWndSlider); 

	SendDlgItemMessage( hWndDlg, IDC_EDIT_SEARCH, EM_SETLIMITTEXT , 30L, 0L);

	ST_CreateStatus(hWndDlg);

	LV_InitColumns(hWndDlg);


	if (gParam.nOnStartup == 0)
		LV_Playlist(hWndDlg, COMDLG_OPEN);
	else
		LV_PlaylistWinamp(hWndDlg, COMDLG_OPEN);


	GetClientRect(hWndDlg, &rect);
	lParam = rect.right - rect.left;  
	lParam |= (rect.bottom - rect.top) << 16; 
	SendMessage(hWndDlg, WM_SIZE , (WPARAM)SIZE_RESTORED, (LPARAM)lParam);

	SetCursor(hcurOld);
}

/* ************************************************************ */
void PlaylistDlg_OwnerDrawBtn (LPDRAWITEMSTRUCT lpdis)
{                                                    
    HDC hDC;
    RECT rect;
	HFONT hFontButton, hOldFont;
	LOGFONT lf;	
	HRGN hRgn;
	POINT pt[4];

    hDC = lpdis->hDC;
    CopyRect (&rect, &(lpdis->rcItem));    

	if (lpdis->CtlID == IDC_BUTTON_OPTION)
	{
		int x, y;
		POINT ptOld;

		switch (lpdis->itemAction) 
		{	
			case ODA_DRAWENTIRE:  
			case ODA_FOCUS:
				DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);
				break;

			case ODA_SELECT:
				if (lpdis->itemState & ODS_SELECTED)
					DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH|DFCS_PUSHED);
				else
					DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);
				
				break;

			default:
				return;

		}

		x  = (rect.right - rect.left - 4)/2;
		y  = (rect.bottom - rect.top - 7)/2;
		
		MoveToEx(hDC, x, y, &ptOld);
		LineTo(hDC,x, y+7);
		MoveToEx(hDC, x+1, y+1, &ptOld);
		LineTo(hDC,x+1, y+6);
		MoveToEx(hDC, x+2, y+2, &ptOld);
		LineTo(hDC,x+2, y+5);
		MoveToEx(hDC, x+3, y+3, &ptOld);
		LineTo(hDC,x+3, y+4);

		return;
	}


	if (lpdis->CtlID == IDC_BUTTON_FILE || lpdis->CtlID == IDC_BUTTON_ADD)
	{
		switch (lpdis->itemAction) 
		{	
			case ODA_DRAWENTIRE:  
			case ODA_FOCUS:
				DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);
				InflateRect(&rect, -2, -2);
				rect.left += 8;
				rect.top  += 1;
				break;

			case ODA_SELECT:
				if (lpdis->itemState & ODS_SELECTED)
				{
					DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH|DFCS_PUSHED);
					InflateRect(&rect, -2, -2);
					rect.left += 9;
					rect.top  += 2;
				}
				else
				{
					DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);
					InflateRect(&rect, -2, -2);
					rect.left += 8;
					rect.top  += 1;
				}
				
				break;

			default:
				return;

		}

		ZeroMemory(&lf,sizeof(lf));
		lstrcpy (lf.lfFaceName, "MS Sans Serif");
		lf.lfHeight = 5;
		lf.lfWidth  = 5;
		lf.lfUnderline = FALSE;
		lf.lfOutPrecision = OUT_TT_PRECIS;
		hFontButton = CreateFontIndirect ((LPLOGFONT) &lf);
		if (hFontButton!=NULL) 
		{
			char szTitle[20];

			if (lpdis->CtlID == IDC_BUTTON_FILE)
				strcpy(szTitle, "File");
			else
				strcpy(szTitle, "Add");

			hOldFont=SelectObject(hDC, hFontButton);
			SetBkMode(hDC,TRANSPARENT);
			SetTextAlign(hDC,TA_LEFT);
			TextOut(hDC,rect.left,rect.top ,szTitle, strlen(szTitle));

			SelectObject(hDC, hOldFont);
			DeleteObject (hFontButton); 
		}

		pt[0].x  = (lpdis->rcItem).right - 16;
		pt[0].y  = (lpdis->rcItem).top + 8;
		pt[1].x = pt[0].x + 7;
		pt[1].y = pt[0].y;
		pt[2].x = pt[0].x + 3;
		pt[2].y = pt[0].y + 4;
		pt[3].x = pt[0].x + 3;
		pt[3].y = pt[0].y + 3;
		hRgn = CreatePolygonRgn((CONST POINT*) &pt,4,WINDING);
		FillRgn(hDC, hRgn, (HBRUSH)GetStockObject(BLACK_BRUSH));
		DeleteObject(hRgn);
	}	

}                                                    

/* ************************************************************ */
void  PlaylistDlg_SetActive(HWND hwndDlg)
{
	if (bColumnsChange == TRUE)
	{
		// Remove old columns
		int i;
		for (i = 0; i < gParam.NbCol; i++)
			ListView_DeleteColumn (m_hwndList, 0);							

		// Calculate used columns
		for (gParam.NbCol = 0, i = 0; i < MAX_COL; i++)
			if (gParam.UseCol[i] != -1) 
			gParam.NbCol++;

		LV_InitColumns(hwndDlg);					
	}

	if (bFilterChange == TRUE)
		LV_UpdatePlaylist(hwndDlg);

}

/* ************************************************************ */
void PlaylistDlg_doScrollSlider(HWND hWnd, HWND hSlider) 
{
	char szLabel[80];
	int nPos;
	
	if (hSlider == GetDlgItem(hWnd, IDC_SLIDER_VOLUME))
	{	
		nPos = (int)SendMessage(hSlider, TBM_GETPOS, 0,0);
		
		SendMessage(plugin.hwndParent, WM_USER, (WPARAM)nPos, 122);
		
		wsprintf(szLabel, "Volume %d%%", (int)(100*nPos)/255);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_VOLUME), (LPSTR)szLabel);
	}
}

/* ************************************************************************ */
void PlaylistDlg_LoadParam(void)
{
	char ini_file[MAX_PATH], *p;
	char szBuffer[80];
	int i, nfilled=0;
	GetModuleFileName(plugin.hDllInstance,ini_file,sizeof(ini_file));
	p=ini_file+lstrlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	lstrcat(ini_file,"plugin.ini");

	for (i = 0; i<MAX_COL; i++)
			gParam.UseCol[i] = -1;

	GetPrivateProfileString(szAppName,"Columns","0,1,2,3,4,5,6,7,8,9,10,11,12",szBuffer,sizeof(szBuffer),ini_file);
	
	nfilled = sscanf(szBuffer, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d",
		&gParam.UseCol[0], 		&gParam.UseCol[1], 		&gParam.UseCol[2], 
		&gParam.UseCol[3],		&gParam.UseCol[4],		&gParam.UseCol[5], 
		&gParam.UseCol[6], 		&gParam.UseCol[7], 		&gParam.UseCol[8],
		&gParam.UseCol[9], 		&gParam.UseCol[10], 	&gParam.UseCol[11], 
		&gParam.UseCol[12]);

	// Si pb de recuiperation initialisation de toutes les colonnes
	// dans l'ordre
	if (nfilled < MAX_COL)
		for (i = 0; i < MAX_COL; i++)
			gParam.UseCol[i] = i;

	// Determine le nombre de colonnes utilisees
	for (gParam.NbCol = 0, i = 0; i < MAX_COL; i++)
			if (gParam.UseCol[i] != -1) 
				gParam.NbCol++;

	// Load in array Format Tag rename filename from TAG
	for (i = 0; i<5; i++)	
		gParam.FrmtCol[i] = -1;

	GetPrivateProfileString(szAppName,"FrmtTag","0,1,-1,-1,-1",szBuffer,sizeof(szBuffer),ini_file);
	nfilled = sscanf(szBuffer, "%d,%d,%d,%d,%d",
		&gParam.FrmtCol[0], 	&gParam.FrmtCol[1], 		&gParam.FrmtCol[2], 
		&gParam.FrmtCol[3],		&gParam.FrmtCol[4]);
	// if Error set default all columns
	if (nfilled < 5)
		for (i = 0; i <5; i++)	gParam.FrmtCol[i] = i;
	
	gParam.bExportAllItems	  = (BOOL)GetPrivateProfileInt(szAppName,"ExportAllItems",0, (LPSTR)ini_file);
	gParam.bExportHTML_Format =	(BOOL)GetPrivateProfileInt(szAppName,"ExportHTMLFormat",0, (LPSTR)ini_file);
	gParam.bExportHTML_Link   = (BOOL)GetPrivateProfileInt(szAppName,"ExportHTMLLink",0, (LPSTR)ini_file);
	gParam.nOptionSearch      = (int)GetPrivateProfileInt(szAppName,"OptionSearch",31, (LPSTR)ini_file);
	gParam.nDblClic           = (BOOL)GetPrivateProfileInt(szAppName,"DblClic",0, (LPSTR)ini_file);
	gParam.nOnStartup         = (BOOL)GetPrivateProfileInt(szAppName,"OnStartup",0, (LPSTR)ini_file);
	gParam.nRemoveTAG         = (BOOL)GetPrivateProfileInt(szAppName,"RemoveTAG",0, (LPSTR)ini_file);

}

/* ************************************************************************ */
void PlaylistDlg_SaveParam(void)
{
	char ini_file[MAX_PATH], *p;
	char szBuffer[80];
	int nfilled=0;
	GetModuleFileName(plugin.hDllInstance,ini_file,sizeof(ini_file));
	p=ini_file+lstrlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	lstrcat(ini_file,"plugin.ini");

	sprintf(szBuffer, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d",
		gParam.UseCol[0],	gParam.UseCol[1], 	gParam.UseCol[2], 
		gParam.UseCol[3],	gParam.UseCol[4],	gParam.UseCol[5], 
		gParam.UseCol[6], 	gParam.UseCol[7], 	gParam.UseCol[8],
		gParam.UseCol[9], 	gParam.UseCol[10],	gParam.UseCol[11], 
		gParam.UseCol[12]);
	WritePrivateProfileString(szAppName,"Columns", szBuffer,ini_file);
		
	sprintf(szBuffer, "%d,%d,%d,%d,%d",
		gParam.FrmtCol[0],	gParam.FrmtCol[1], 	gParam.FrmtCol[2], 
		gParam.FrmtCol[3],	gParam.FrmtCol[4]);
	WritePrivateProfileString(szAppName,"FrmtTAG", szBuffer,ini_file);

	WritePrivateProfileString(szAppName,"ExportAllItems",
		gParam.bExportAllItems ? "1":"0", (LPSTR)ini_file);

	WritePrivateProfileString(szAppName,"ExportHTMLFormat",
		gParam.bExportHTML_Format ? "1":"0", (LPSTR)ini_file);

	WritePrivateProfileString(szAppName,"ExportHTMLLink",
		gParam.bExportHTML_Link ? "1":"0", (LPSTR)ini_file);

	wsprintf(szBuffer,"%d",gParam.nOptionSearch);
	WritePrivateProfileString(szAppName,"OptionSearch",
		szBuffer, (LPSTR)ini_file);

	wsprintf(szBuffer,"%d",gParam.nDblClic);
	WritePrivateProfileString(szAppName,"DblClic",
		szBuffer, (LPSTR)ini_file);

	wsprintf(szBuffer,"%d",gParam.nOnStartup);
	WritePrivateProfileString(szAppName,"OnStartup",
		szBuffer, (LPSTR)ini_file);

	wsprintf(szBuffer,"%d",gParam.nRemoveTAG);
	WritePrivateProfileString(szAppName,"RemoveTAG",
		szBuffer, (LPSTR)ini_file);


}


/* ************************************************************************ */
void LV_InitColumns(HWND hWndDlg)
{
	HIMAGELIST hSmall;
	HICON hIcon[3];
	LV_COLUMN lvc;				// list view column structure
	char szText[80];
	int i, k;

	// initialise le ListView / Colonnes
	m_hwndList = GetDlgItem(hWndDlg, IDC_LVW_PLAYLIST);

	ListView_SetExtendedListViewStyle(m_hwndList, LVS_EX_FULLROWSELECT);

	// Create Imagelist / small Icon
	// Associate the image lists with the list view control.
	hSmall = ImageList_Create (16, 16,	 ILC_COLOR16 | ILC_MASK, 3, 0);

	for (i=0; i<3;i++)
	{	
		hIcon[i] = LoadIcon (plugin.hDllInstance, MAKEINTRESOURCE (IDI_ICON8+i));
		ImageList_AddIcon (hSmall, hIcon[i]);
	}
	
	ListView_SetImageList (m_hwndList, hSmall, LVSIL_SMALL);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.pszText = szText;

	for (i = 0; i<gParam.NbCol; i++)
	{
		k = gParam.UseCol[i];

		lvc.iSubItem = i;
		lvc.fmt = gCol[k].nAlignment;		// left-align column
		lvc.cx = gCol[k].nWidth;			// width of column in pixels
		strcpy(szText, gCol[k].szName);
		ListView_InsertColumn (m_hwndList, i, &lvc);
	}

}

/* ************************************************************************ */
void LV_New(HWND hwndDlg)
{
	int iItem = Item_DeleteAll();

	LV_Redraw(FALSE);

	ListView_DeleteAllItems(m_hwndList); 
	
	nTotalLength = 0;
	nAvgLength   = 0;
	UpdateStatus(hwndDlg);
	LV_StatGenre();
	
	LV_Redraw(TRUE);
}

/* ************************************************************************ */
void LV_ComDlg(HWND hwndDlg, int nMode)
{
	OPENFILENAME ofn; 
	char szDirName[256];
	char szFile[256];
	char szFileTitle[256]; 
	char szFilter[] = "EZ-Playlist (*.EZ3)|*.EZ3|";
    
    SetFilter(szFilter);
	GetCurrentDirectory(sizeof(szDirName), (LPSTR)szDirName);
	*szFile = '\0'; 

	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = hwndDlg; 
	ofn.lpstrFilter = szFilter; 
	ofn.lpstrCustomFilter = (LPSTR) NULL; 
	ofn.nMaxCustFilter = 0L; 
	ofn.nFilterIndex = 0L; 
	ofn.lpstrFile = szFile; 
	ofn.nMaxFile = sizeof(szFile); 
	ofn.lpstrFileTitle = szFileTitle; 
	ofn.nMaxFileTitle = sizeof(szFileTitle); 
	ofn.lpstrInitialDir = szDirName; 
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY; 
	ofn.nFileOffset = 0; 
	ofn.nFileExtension = 0; 
	ofn.lpstrDefExt = (LPSTR)NULL; 

	if (nMode == COMDLG_OPEN)
	{
		ofn.lpstrTitle = (LPCSTR)"Open EZ-Playlist"; 
		if (GetOpenFileName(&ofn) == 0) 
			return;
		LV_LoadEZ3(szFile, hwndDlg);
	}
	else
	{
		ofn.lpstrTitle = (LPCSTR)"Save EZ-Playlist"; 
		if (GetSaveFileName(&ofn) == 0) 
			return;
		strcat(szFile, ".EZ3");
		LV_WriteEZ3(szFile);
	}

}

/* ************************************************************************ */
void LV_Playlist(HWND hWndDlg, int nOpen)
{
	char filename[255];
	char *p;
	
	GetModuleFileName(plugin.hDllInstance,filename,sizeof(filename));
	p = filename + lstrlen(filename);
	while (p >= filename && *p != '.') p--;
	p++;
	*p++ = 'E';
	*p++ = 'Z';
	*p++ = '3';
	*p = '\0';
	
	if (nOpen == COMDLG_OPEN)
		LV_LoadEZ3(filename, hWndDlg);
	else
		LV_WriteEZ3(filename);
}

/* ************************************************************************ */
void LV_PlaylistWinamp(HWND hWndDlg, int nOpen)
{
	char filename[255];
	HMODULE hModuleWinamp;
	char *p;
	
	hModuleWinamp = (HMODULE)GetClassLong(plugin.hwndParent, GCL_HMODULE);
	GetModuleFileName(hModuleWinamp,filename,sizeof(filename));
	p = filename + lstrlen(filename);
	while (p >= filename && *p != '.') p--;
	p++;
	*p++ = 'm';
	*p++ = '3';
	*p++ = 'u';
	*p = '\0';
	
	if (nOpen == COMDLG_OPEN)
	{
		// Writes out the current playlist to Winampdir \winamp.m3u
		SendMessage(plugin.hwndParent, WM_USER, 0,120);
		LV_LoadM3U(filename, hWndDlg);
	}
	else
	{
		COPYDATASTRUCT cds;
		
		if (LV_WriteM3U(filename) == FALSE)
			return;

		// Efface l'ancienne playlist de WinAMP et ajoute la nvelle
		SendMessage(plugin.hwndParent, WM_USER, 0,101);

		cds.dwData = 100;
		cds.lpData = (void*)filename;
		cds.cbData = strlen((char*)cds.lpData)+1;
		SendMessage(plugin.hwndParent, WM_COPYDATA, (WPARAM)NULL,(LPARAM)&cds);
	}

}


/* ************************************************************************ */
void LV_LoadEZ3(char *filename, HWND hWndDlg)
{
	FILE *file;	
	char szTemp[1024], *p;
	char szTitle[1024];
	EZ3HEADER header;
	int iItem, nLenFileName, nImage;
	LV_ITEM lvi;
	MYITEM *pItem = NULL; 

	if ( (file = fopen(filename,"rb")) == NULL)
		return;

	if (fread(&header, 1, sizeof(header), file) != sizeof(header))
	{	fclose(file);
		MessageBox(hWndDlg, "Error file: EZ-Playlist", "Error", MB_OK|MB_ICONSTOP);
		return;
	}

	if (strncmp(header.tag, "EZ3DATA", 7) != 0)
	{	fclose(file);
		MessageBox(hWndDlg, "Bad file format: EZ-Playlist", "Error",MB_OK|MB_ICONSTOP);
		return;
	}


	//Turn the listview's redrawing off 
	LV_Redraw(FALSE);
	ListView_DeleteAllItems(m_hwndList); 
	iItem = Item_DeleteAll();

	
    // Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	nTotalLength = 0;
	
	// Scan playlist Winamp
	for (iItem = 0; iItem < header.nCountFile; iItem++)
	{
		// FullFileName Path+Filename
		*szTemp = '\0';
		fread(&nLenFileName, sizeof(nLenFileName), 1, file);
		fread(szTemp, sizeof(char), nLenFileName, file);
		p = szTemp + nLenFileName;
		*p = '\0';

		// Title filename in playlist
		*szTitle = '\0';
		fread(&nLenFileName, sizeof(nLenFileName), 1, file);
		fread(szTitle, sizeof(char), nLenFileName, file);
		p = szTitle + nLenFileName;
		*p = '\0';

		fread(&nImage, sizeof(nImage), 1, file);
		fread(&gPlayList, sizeof(gPlayList), 1, file);

		// Allocate an application-defined structure to store the 
		// item label and the text of each subitem. 
		pItem = Item_New(pItem, (LPSTR)szTemp);
		pItem->pData->titleplaylist =  DupString(szTitle); 
		pItem->nImage = nImage;
				
		// Initialize item-specific LVITEM members.         
		// Add the item.         
		lvi.iItem = iItem; 
		lvi.iImage = nImage;
		lvi.iSubItem = 0;         
		lvi.lParam = (LPARAM) pItem;    // item data  
		ListView_InsertItem(m_hwndList, &lvi);  
		
		nTotalLength += pItem->pData->length;
	}

	fclose(file);

	UpdateStatus(hWndDlg);
	LV_Redraw(TRUE);
	LV_StatGenre();
	
}


/* ************************************************************************ */
void LV_LoadM3U(char *filename, HWND hWndDlg)
{
	char szTemp[1024];
	FILE *filePlaylist;		
	BOOL bExtM3U;
	char *p;
	int iItem, nImage;
	LV_ITEM lvi;
	MYITEM *pItem = NULL; 
	
	if ( (filePlaylist = fopen(filename, "r+t")) == NULL)
		return;
	
	LV_Redraw(FALSE);
	ListView_DeleteAllItems(m_hwndList); 
	iItem = Item_DeleteAll();
	
    // Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	nTotalLength = 0;
	
	// Scan playlist Winamp
	for (iItem = 0; 
		fgets(szTemp, 1024, filePlaylist);
		iItem++)
	{

		// 1st detect is extented playlist  ?
		if (iItem == 0)
		{	bExtM3U = (strncmp(szTemp, "#EXTM3U", 7) == 0 ? TRUE :FALSE);
			continue;
		}

		// Skip extended information if exist
		if (bExtM3U)
			if(strncmp(szTemp, "#EXTINF", 7)==0)
				fgets(szTemp, 1024, filePlaylist);

		// Read info media filename	 
		p = szTemp + strlen(szTemp) -1;
		*p = '\0';
		
		nImage = mpg123_file_info(szTemp);

		// Allocate an application-defined structure to store the 
		// item label and the text of each subitem. 
		pItem = Item_New(pItem, (LPSTR)szTemp);
		pItem->nImage = nImage;
				
		// Initialize item-specific LVITEM members.         
		// Add the item.         
		lvi.iItem = iItem; 
		lvi.iImage = nImage;
		lvi.iSubItem = 0;         
		lvi.lParam = (LPARAM) pItem;    // item data  
		ListView_InsertItem(m_hwndList, &lvi);  
		
		nTotalLength += pItem->pData->length;
	}

	fclose(filePlaylist);
	
	UpdateStatus(hWndDlg);
	LV_Redraw(TRUE);
	LV_StatGenre();
}

/* ************************************************************************ */
void LV_LoadPLS(char *filename, HWND hWndDlg)
{
	char szTemp[1024];
	FILE *filePlaylist;		
	char *p, *szFile;
	int iItem, nImage;
	LV_ITEM lvi;
	MYITEM *pItem = NULL; 
	
	if ( (filePlaylist = fopen(filename, "r+t")) == NULL)
		return;
	
	LV_Redraw(FALSE);
	ListView_DeleteAllItems(m_hwndList); 
	iItem = Item_DeleteAll();
	
    // Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	nTotalLength = 0;
	
	// Scan playlist Winamp
	for (iItem = 0; 
		fgets(szTemp, 1024, filePlaylist);
		iItem++)
	{

		// 1st detect is extented playlist  ?
		if (iItem == 0)
		{	if(strncmp(szTemp, "[playlist]", 10) != 0)
			{
				MessageBox(hWndDlg, "Bad file: PLS playlist", "Error", MB_OK|MB_ICONSTOP);
				return;
			}
		}

		// Skip extended information if exist
		if(strncmp(szTemp, "File", 4) !=0)
			continue;

		p = strchr(szTemp, '=');
		if (p==0)
			continue;
		else
			p++;	
		
		szFile = p;

		// Read info media filename	 
		p = szFile + strlen(szFile) -1;
		*p = '\0';
		
		nImage = mpg123_file_info(szFile);

		// Allocate an application-defined structure to store the 
		// item label and the text of each subitem. 
		pItem = Item_New(pItem, (LPSTR)szFile);
		pItem->nImage = nImage;
				
		// Initialize item-specific LVITEM members.         
		// Add the item.         
		lvi.iItem = iItem; 
		lvi.iImage = nImage;
		lvi.iSubItem = 0;         
		lvi.lParam = (LPARAM) pItem;    // item data  
		ListView_InsertItem(m_hwndList, &lvi);  
		
		nTotalLength += pItem->pData->length;
	}

	fclose(filePlaylist);
	
	UpdateStatus(hWndDlg);
	LV_Redraw(TRUE);
	LV_StatGenre();
}

/* ************************************************************************ */
void LV_WriteEZ3(char* filename)
{
	FILE *file;		
	EZ3HEADER header;
	int i, nCount, nLen;
	LV_ITEM lvi;
	MYITEM *pItem = NULL; 
	
	if ( (file = fopen(filename,"wb")) == NULL)
		return;

	nCount = ListView_GetItemCount(m_hwndList);

	strcpy(header.tag, "EZ3DATA");
	header.nCountFile = nCount;
	fwrite (&header, sizeof(header), 1, file);
	
	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_PARAM; 
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;
	
		nLen = lstrlen(pItem->pFileName);
		fwrite (&nLen, sizeof(nLen), 1, file);
		fwrite (pItem->pFileName, sizeof(char), nLen, file);

		nLen = lstrlen(pItem->pData->titleplaylist);
		fwrite (&nLen, sizeof(nLen), 1, file);
		fwrite (pItem->pData->titleplaylist, sizeof(char), nLen, file);

		fwrite (&pItem->nImage, sizeof(pItem->nImage), 1, file);
		fwrite (pItem->pData, sizeof(PLAYLISTSTRUCT), 1, file);
	}

	fclose(file);
}

/* ************************************************************************ */
BOOL LV_WriteM3U(char *filename)
{
	FILE *file;		// winamp.m3u playlist
	int i, nCount;
	LV_ITEM lvi;
	MYITEM *pItem;
	
	if ( (file = fopen(filename,"w+t")) == NULL)
		return FALSE;

	nCount = ListView_GetItemCount(m_hwndList);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED; 
	 
	fprintf(file, "#EXTM3U\n");

	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		if (gParam.bExportAllItems == 1 && (lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
			continue;

		fprintf(file, "#EXTINF,%d,%s - %s\n",
			pItem->pData->length,
			pItem->pData->artist,
			pItem->pData->title);

		fprintf(file, "%s\n",(char*)pItem->pFileName);
	
	}
	fclose(file);

	return TRUE;
}


/* ************************************************************************ */
BOOL LV_WritePLS(char *filename)
{
	FILE *file;		// winamp.m3u playlist
	int i, nCount;
	LV_ITEM lvi;
	MYITEM *pItem;
	
	if ( (file = fopen(filename,"w+t")) == NULL)
		return FALSE;

	nCount = ListView_GetItemCount(m_hwndList);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED; 
	
	fprintf(file, "[playlist]\n");

	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		if (gParam.bExportAllItems == 1 && (lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
			continue;

		fprintf(file, "File%d=%s\nTitle%d=%s - %s\nLength%d=%d\n", 
			i+1, 
			(char*)pItem->pFileName,
			i+1,
			pItem->pData->artist, 
			pItem->pData->title,
			i+1,
			pItem->pData->length);
			
		
	
	}
	fprintf(file, "NumberOfEntries=%i\nVersion=2",nCount);
	fclose(file);

	return TRUE;
}

/* ************************************************************************ */
BOOL LV_WriteHTML_Table(char* filename)
{
	FILE *file;		// playlist HTML format
	int i,k,nCount;
	int iColArtist;
	LV_ITEM lvi;
	MYITEM *pItem;
	char *title, *p; 
	char szCol[256];
	unsigned long uTotalSize = 0;

	if ( (file = fopen(filename,"w+t")) == NULL)
		return FALSE;


	title = strrchr(filename, '\\');
	if (!title)
		title = filename;
	else
		title++;

	p = strrchr(title, '.');
	if (p) 	*p = '\0';

	nCount = ListView_GetItemCount(m_hwndList);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED;  


	if (gParam.bExportHTML_Link==1) 
	{
		for (i = 0; i < gParam.NbCol; i++)
		{	
			if(gParam.UseCol[i]==0)
			{
				iColArtist = i;
				break;
			}
		}	
	}		
	

	// Header /Body structure
	fprintf(file, "<html><head><title>%s</title></head>\n<body><center>		\
		<h1>Playlist page:%s</h1></center>\n<font size=\"1\">\n<table		\
		border=1 cellpadding=5 cellspacing=0>\n", title, title);

	
	// Table header , columns header
	fprintf(file, "<tr BGCOLOR=\"#C0C0C0\">\n");
	fprintf(file, "<th>N</th>");	
	for (i = 0; i < gParam.NbCol; i++)
	{	k = gParam.UseCol[i];
		fprintf(file, "<th>%s</th>", gCol[k].szName);
	}
	fprintf(file, "\n</tr>\n");

	for (i = 0; i< nCount; i++)
	{
		// New begin row
		fprintf(file, "<tr>\n");

		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		if (gParam.bExportAllItems == 1 && (lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
			continue;

		uTotalSize += pItem->pData->filesize;

		fprintf(file, "<td><font size=\"2\">%i</font></td>\n",i+1);

		// Scan all columns
		for (k = 0; k < gParam.NbCol; k++)
		{
			LV_GetInfoCol(pItem, k, szCol); 	
			
			if (gParam.bExportHTML_Link == 1 && k == iColArtist) 
			{
				if (strlen(szCol) != 0)
					//  nowrap
					fprintf(file, "<td nowrap><font size=\"2\"><a href =\"%s\">%s</a></font></td>\n",
						pItem->pFileName, szCol);
				else
					fprintf(file, "<td><font size=\"2\"><a href =\"%s\">&nbsp;</a></font></td>\n", pItem->pFileName);
				
			}
			else
			{
				
				if (strlen(szCol) != 0)
					//  nowrap
					fprintf(file, "<td nowrap><font size=\"2\">%s</font></td>\n",szCol);
				else
					fprintf(file, "<td><font size=\"2\">&nbsp;</font></td>\n");
			}

		}

		// End begin row
		fprintf(file, "</tr>\n");
	
	}
	// End table
	fprintf(file, "</table></font><hr>\n");

	// Description 
	fprintf(file, "Total files: %i<br>\n", nCount);
	fprintf(file, "Total size: %u MB<br>\n", uTotalSize/1024/1024);
	
	Time2String(nTotalLength, szCol, FALSE);
	fprintf(file, "Total length: %s<br>\n", szCol);

	Time2String(nAvgLength, szCol, TRUE);
	fprintf(file, "Average length: %s<br>\n\n", szCol);

	fprintf(file, "<hr>This list was created with <a href=\"http://perso.club-internet.fr/boyerjl\">EZ-Playlist for Winamp</a>");
	fprintf(file, " version 1.0, &copy; ");
	fprintf(file, "<a href=\"mailto:boyerjl@club-internet.fr\">");
	fprintf(file, "JL Boyer</a> france.\n\n");

	fprintf(file, "Date: %s", GetFormattedDateTime());

	fprintf(file, "</body></html>\n");

	fclose(file);

	return TRUE;
}

/* ************************************************************************ */
BOOL LV_WriteHTML_Listing(char* filename)
{
	FILE *file;		// playlist HTML format
	int i,k,nCount;
	LV_ITEM lvi;
	MYITEM *pItem;
	char *title, *p; 
	char szCol[256];
	unsigned long uTotalSize = 0;

	if ( (file = fopen(filename,"w+t")) == NULL)
		return FALSE;

	title = strrchr(filename, '\\');
	if (!title)
		title = filename;
	else
		title++;

	p = strrchr(title, '.');
	if (p) 	*p = '\0';

	nCount = ListView_GetItemCount(m_hwndList);

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED;  

	// Header /Body structure
	fprintf(file, "<html><head><title>%s</title></head>\n<body><font face =\"Arial\" size=\"2\"><center>		\
		<h1>Playlist file:%s</h1></center>\n\n", title, title);

	
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		if (gParam.bExportAllItems == 1 && (lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
			continue;

		uTotalSize += pItem->pData->filesize;
		

		// Title: Artist & Length
		if (gParam.bExportHTML_Link == 1) 
		{
			fprintf(file, "<a href =\"%s\">%s - %s</a><BR>\n",
				pItem->pFileName, 
				pItem->pData->artist, 
				pItem->pData->title); 
		}
		else
		{
			fprintf(file, "<B>%s - %s</B><BR>\n",
				pItem->pData->artist, 
				pItem->pData->title); 
		}


		// Scan all columns except Artist and length
		for (k = 0; k < gParam.NbCol; k++)
		{
			if (gParam.UseCol[k] > 1)
			{
				LV_GetInfoCol(pItem, k, szCol); 	
				fprintf(file, "- %s: %s<BR>\n",gCol[gParam.UseCol[k]].szName,szCol);
			}
		}
		
		fprintf(file, "<BR>\n");		// seperate line between songs
			
	}
	
	// Description 
	fprintf(file, "<hr>\n");
	fprintf(file, "Total files: %i<br>\n", nCount);
	fprintf(file, "Total size: %u MB<br>\n", uTotalSize/1024/1024);
	
	Time2String(nTotalLength, szCol, FALSE);
	fprintf(file, "Total length: %s<br>\n", szCol);

	Time2String(nAvgLength, szCol, TRUE);
	fprintf(file, "Average length: %s<br>\n\n", szCol);

	fprintf(file, "<hr>This list was created with <a href=\"http://perso.club-internet.fr/boyerjl\">EZ-Playlist for Winamp</a>");
	fprintf(file, " version 1.0, &copy; ");
	fprintf(file, "<a href=\"mailto:boyerjl@club-internet.fr\">");
	fprintf(file, " JL  Boyer</a> france.\n\n");
	
	fprintf(file, "Date: %s\n\n", GetFormattedDateTime());

	fprintf(file, "</font></body></html>\n");

	fclose(file);

	return TRUE;
}

/* ************************************************************************ */
BOOL LV_WriteASCII(char* filename)
{
	FILE *file;		// playlist ASCII text format
	int i,k,nCount;
	LV_ITEM lvi;
	MYITEM *pItem;
	char szCol[256];

	if ( (file = fopen(filename,"w+t")) == NULL)
		return FALSE;

	nCount = ListView_GetItemCount(m_hwndList);
	
	for (i = 0; i < gParam.NbCol; i++)
	{	k = gParam.UseCol[i];
		if (i != gParam.NbCol -1)	
			fprintf(file, "%s\t", gCol[k].szName);
		else
			fprintf(file, "%s\n", gCol[k].szName);
	}

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask =  LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED; 

	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		if (gParam.bExportAllItems == 1 && (lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
			continue;

		// Scan all columns
		for (k = 0; k < gParam.NbCol; k++)
		{
			LV_GetInfoCol(pItem, k, szCol); 	
			if (k != gParam.NbCol -1)
				fprintf(file, "%s\t",szCol);
			else
				fprintf(file, "%s\n", szCol);

		}
	
	}
	
	fclose(file);
	return TRUE;
}

/* ************************************************************************ */
void LV_AddFiles(HWND hwndDlg)
{
	OPENFILENAME ofn; 
	char szDirName[256];
	char szFile[16384];
	char szFileTitle[256]; 
	char szFilter[] = "MPEG Audio Files (*.MP1;*.MP2;*.MP3)|*.MP1;*.MP2;*.MP3|Microsoft Waveform Audio Files (*.WAV)|*.WAV|";

	SetFilter(szFilter);
	GetCurrentDirectory(sizeof(szDirName), (LPSTR)szDirName);
	*szFile = '\0'; 	
	
	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = NULL; //hwndDlg; 
	ofn.lpstrFilter = szFilter; 
	ofn.lpstrCustomFilter = (LPSTR) NULL; 
	ofn.nMaxCustFilter = 0L; 
	ofn.nFilterIndex = 0L; 
	ofn.lpstrFile = szFile; 
	ofn.nMaxFile = sizeof(szFile); 
	ofn.lpstrFileTitle = szFileTitle; 
	ofn.nMaxFileTitle = sizeof(szFileTitle); 
	ofn.lpstrInitialDir = szDirName; 
	ofn.lpstrTitle = (LPCSTR)"Add files"; 
	ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER; 
	ofn.nFileOffset = 0; 
	ofn.nFileExtension = 0; 
	ofn.lpstrDefExt = (LPSTR)NULL; 	
	
	if (GetOpenFileName(&ofn) == 0) 
	{
		if (CommDlgExtendedError() == FNERR_BUFFERTOOSMALL)
			MessageBox(hwndDlg, "Too many files selected", "Add files Error", MB_OK|MB_ICONSTOP); 
		return;
	}

	else
	{
		char szCurDirName[MAX_PATH];
		char szPath[MAX_PATH];
		size_t size;
		int iItem, nImage;
		LV_ITEM lvi;
		MYITEM *pItem = NULL; 
	
		// Initialize LVITEM members that are common to all items. 
		lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
		lvi.state = 0;     
		lvi.stateMask = 0; 
		lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

		GetCurrentDirectory(sizeof(szCurDirName), (LPSTR)szCurDirName );
		size = strlen(szFile);

		if (strlen(szCurDirName) != size)
		{
			//Only one file selected
			nImage = mpg123_file_info(szFile);
			
			pItem = Item_GetLast();
			pItem = Item_New(pItem, (LPSTR)szFile);
			pItem->nImage = nImage;
						
			iItem = ListView_GetItemCount(m_hwndList);

			lvi.iItem = iItem; 
			lvi.iImage = nImage;
			lvi.iSubItem = 0;         
			lvi.lParam = (LPARAM) pItem;    // item data  
			ListView_InsertItem(m_hwndList, &lvi);  
				
			nTotalLength += pItem->pData->length;
		}
		else
		{
			// multiselected files
			BOOL bExit = FALSE;

			strcpy(szPath, szFile);
			strcat(szPath, "\\");

			while (!bExit)
			{
				
				char *pFile = szFile + size + 1;
				int filesize = strlen(pFile);
				
				if (!filesize)
					bExit = TRUE;
				else
				{
					char szTemp[1024];

					size += (filesize + 1);

					strcpy(szTemp, szPath);
					strcat(szTemp, pFile);
	
					nImage = mpg123_file_info(szTemp);
			
					pItem = Item_GetLast();
					pItem = Item_New(pItem, (LPSTR)szTemp);
					pItem->nImage = nImage;
								
					iItem = ListView_GetItemCount(m_hwndList);

					lvi.iItem = iItem; 
					lvi.iImage = nImage;
					lvi.iSubItem = 0;         
					lvi.lParam = (LPARAM) pItem;    // item data  
					ListView_InsertItem(m_hwndList, &lvi);  
						
					nTotalLength += pItem->pData->length;
				}
			
			
			}
	
		}

		UpdateStatus(hwndDlg);
		LV_StatGenre();
	}

}



/* ************************************************************************ */
void LV_AddDirectory(HWND hwndDlg)
{
	char szDir[MAX_PATH];
	BROWSEINFO bi;
	LPITEMIDLIST pidlBrowse;
	
	GetCurrentDirectory(MAX_PATH, szDir);

	bi.hwndOwner = hwndDlg;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szDir;
	bi.lpszTitle = NULL;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = myBrowseCallbackProc;
	bi.lParam = (LPARAM)szDir;
	bi.iImage = 0;
	pidlBrowse = SHBrowseForFolder(&bi);
	
	if (pidlBrowse) 
	{
		char *p;
		HCURSOR hcurOld;

		SHGetPathFromIDList(pidlBrowse, szDir);

		p = szDir + strlen(szDir) - 1;
		if (*p == '\\')	*p = '\0';

		gpEndItem = Item_GetLast(); 
		
		LV_Redraw(FALSE);
		ST_ChangeText((LPSTR)"Scanning...", 0);
		ST_ChangeText((LPSTR)"", 1);
		ST_ChangeText((LPSTR)"", 2);
	
		hcurOld = SetCursor(LoadCursor(NULL, IDC_WAIT));

		LV_AddDir2List(szDir);

		SetCursor(hcurOld);
	
		LV_Redraw(TRUE);
		LV_StatGenre();
		UpdateStatus(hwndDlg);	
		

	/* 
	
	## pb compilation !!!!!!!!!
	##	
	## LPMALLOC ppMalloc;
	## SHGetMalloc(&ppMalloc);
	## SHGetPathFromIDList(pidlBrowse, szDir);
	## ppMalloc->Free(pidlBrowse);
	##
	## error C2039: 'Free' : is not a member of 'IMalloc'
	## c:\program files\microsoft visual studio\vc98\include\objidl.h(846) : see declaration of 'IMalloc'		
	*/
	
	}
}

/* ************************************************************************ */
void LV_AddDir2List(char* dir)
{    
	WIN32_FIND_DATA data;
	HANDLE hFile;
    char* buffer;
	
	buffer = (char*)malloc(MAX_PATH);    
	sprintf(buffer, "%s\\*", dir);
    
	hFile = FindFirstFile(buffer, &data);

    if(hFile != INVALID_HANDLE_VALUE) 
	{        
		do 
		{
            if (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) 
			{
                if (strcmp(".", data.cFileName) != 0 && strcmp("..", data.cFileName) != 0) 
				{
                    char* subDir;
					
					subDir = (char*)malloc(MAX_PATH);
                    sprintf(subDir, "%s\\%s", dir, data.cFileName);
                    
					LV_AddDir2List(subDir);
                    
					free(subDir);
                }
            } 
			else 
			{
				char *p = NULL;
				
				CharLower(data.cFileName);
                
				p = strstr(data.cFileName, ".mp3");
                if (p) 
				{
					LV_ITEM lvi;
					int nImage, iItem;
					char szTemp[256];
					
					// Initialize LVITEM members that are common to all items. 
					lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
					lvi.state = 0;     
					lvi.stateMask = 0; 
					lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 
					
					sprintf(szTemp, "%s\\%s", dir, data.cFileName);
					nImage = mpg123_file_info(szTemp);
					if (nImage != -1)
					{
						gpEndItem = Item_New(gpEndItem, (LPSTR)szTemp);
						gpEndItem->nImage = nImage;
									
						iItem = ListView_GetItemCount(m_hwndList);

						lvi.iItem = iItem; 
						lvi.iImage = nImage;
						lvi.iSubItem = 0;         
						lvi.lParam = (LPARAM) gpEndItem;    // item data  
						ListView_InsertItem(m_hwndList, &lvi);  
							
						nTotalLength += gpEndItem->pData->length;

						p = data.cFileName;
						*p = toupper(*p);
						ST_ChangeText((LPSTR)data.cFileName, 2);
					}
                }            
			}
		}while(FindNextFile(hFile, &data)); 

        FindClose(hFile);    
	}    
	
	free(buffer);
}

/* ******************************************************* */
static int CALLBACK myBrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED)
	{
		SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
	}
	return(0);
}




/* ************************************************************ */
void LV_Import(HWND hwndDlg)
{
	OPENFILENAME ofn; 
	char szDirName[256]; 
	char szFile[256];
	char szFileTitle[256]; 
    char szFilter[] = "M3U Playlist file (*.M3U)|*.M3U|PLS Playlist file (*.PLS)|*.PLS|";
    
	SetFilter(szFilter);
	GetCurrentDirectory(sizeof(szDirName), (LPSTR)szDirName);
	*szFile = '\0'; 

	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = hwndDlg; 
	ofn.lpstrFilter = szFilter; 
	ofn.lpstrCustomFilter = (LPSTR) NULL; 
	ofn.nMaxCustFilter = 0L; 
	ofn.nFilterIndex = 0L; 
	ofn.lpstrFile = szFile; 
	ofn.nMaxFile = sizeof(szFile); 
	ofn.lpstrFileTitle = szFileTitle; 
	ofn.nMaxFileTitle = sizeof(szFileTitle); 
	ofn.lpstrInitialDir = szDirName; 
	ofn.lpstrTitle = (LPCSTR)"Import playlist"; 
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY; 
	ofn.nFileOffset = 0; 
	ofn.nFileExtension = 0; 
	ofn.lpstrDefExt = (LPSTR)NULL; 

	if (GetOpenFileName(&ofn)) 
	{ 
		switch (ofn.nFilterIndex) 
		{
			case 1:
				LV_LoadM3U(szFile, hwndDlg);
				break;
			case 2:
				LV_LoadPLS(szFile, hwndDlg);
				break;
		}
	} 
}


/* ************************************************************ */
void LV_Export(HWND hwndDlg)
{
	OPENFILENAME ofn; 
	char szDirName[256]; 
	char szFile[256];
	char szFileTitle[256]; 
	char szFilter[] = "ASCII File (*.TXT)|*.TXT|HTML File (*.HTML)|*.HTML|M3U Playlist file (*.M3U)|*.M3U|PLS Playlist file (*.PLS)|*.PLS|";
   
	SetFilter(szFilter);
	GetCurrentDirectory(sizeof(szDirName), (LPSTR)szDirName);
	*szFile = '\0'; 

	ofn.lStructSize = sizeof(OPENFILENAME); 
	ofn.hwndOwner = hwndDlg; 
	ofn.lpstrFilter = szFilter; 
	ofn.lpstrCustomFilter = (LPSTR) NULL; 
	ofn.nMaxCustFilter = 0L; 
	ofn.nFilterIndex = 0L; 
	ofn.lpstrFile = szFile; 
	ofn.nMaxFile = sizeof(szFile); 
	ofn.lpstrFileTitle = szFileTitle; 
	ofn.nMaxFileTitle = sizeof(szFileTitle); 
	ofn.lpstrInitialDir = szDirName; 
	ofn.lpstrTitle = (LPCSTR)"Export data"; 
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY; 
	ofn.nFileOffset = 0; 
	ofn.nFileExtension = 0; 
	ofn.lpstrDefExt = (LPSTR)NULL; 

	if (GetSaveFileName(&ofn)) 
	{ 
		switch (ofn.nFilterIndex) 
		{
		case 1:
			strcat(szFile, ".txt");
			LV_WriteASCII(szFile);
			break;
		case 2:
			strcat(szFile, ".html");
			if (gParam.bExportHTML_Format == 0)
				LV_WriteHTML_Table(szFile);
			else
				LV_WriteHTML_Listing(szFile);
			break;
		case 3:
			strcat(szFile, ".m3u");
			LV_WriteM3U(szFile);
			break;
		case 4:
			strcat(szFile, ".pls");
			LV_WritePLS(szFile);
			break;
		}
	} 
}





/* ************************************************************ */
BOOL PlaylistDlg_doContextMenu(HWND hWnd, WPARAM wParam, LPARAM lParam) 
{ 
	HWND  hwndListView = (HWND)wParam; 
	HMENU hMenuLoad, hMenu; 

	if(hwndListView != GetDlgItem(hWnd, IDC_LVW_PLAYLIST)) 
		return FALSE; 

	hMenuLoad = LoadMenu(plugin.hDllInstance, MAKEINTRESOURCE(IDR_MENU1)); 
	
	// subMenu WinAMP
	hMenu = GetSubMenu(hMenuLoad, 1); 

	PlaylistDlg_UpdateMenu(hwndListView, hMenu); 

	TrackPopupMenu(hMenu, 
				  TPM_LEFTALIGN | TPM_RIGHTBUTTON, 
				  LOWORD(lParam), 
				  HIWORD(lParam), 
				  0, 
				  hWnd, 
				  NULL); 

	DestroyMenu(hMenuLoad); 

	return TRUE; 
} 

/* ************************************************************ */
void PlaylistDlg_MenuButton(HWND hwndDlg, int nButton) 
{ 
	HMENU hMenuLoad, hMenu; 
	HWND hwndButton;
	RECT rect;
	POINT pt;

	hMenuLoad = LoadMenu(plugin.hDllInstance, MAKEINTRESOURCE(IDR_MENU1)); 
	
	// subMenu File
	switch (nButton)
	{ 
	case IDC_BUTTON_FILE:
		hMenu = GetSubMenu(hMenuLoad, 0); 
		
		break;
	case IDC_BUTTON_ADD:
		hMenu = GetSubMenu(hMenuLoad, 3); 
		break;
	case IDC_BUTTON_OPTION:
		{
			int i;

			hMenu = GetSubMenu(hMenuLoad, 4); 
			
			for (i=0; i<5; i++)
			{
				CheckMenuItem(hMenu, ID_SEARCH_ARTIST + i,  
					(gParam.nOptionSearch & (1<<i) )? 
					MF_BYCOMMAND | MF_CHECKED :
					MF_BYCOMMAND | MF_UNCHECKED);
				
			}
		}
		break;
	default:
		return;
	}

	hwndButton = GetDlgItem(hwndDlg, nButton); 
	GetClientRect(hwndButton, &rect);
	pt.x  = rect.left;
	pt.y  = rect.bottom;
	ClientToScreen(hwndButton, &pt);

	TrackPopupMenu(hMenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, 
		pt.x, pt.y, 0, hwndDlg, NULL); 

	DestroyMenu(hMenuLoad); 

} 

/* ************************************************************ */
void PlaylistDlg_MenuCheckItem(int nItem)
{
	gParam.nOptionSearch ^=  1<<nItem;
}

/* ************************************************************ */
void PlaylistDlg_UpdateMenu(HWND hwndListView, HMENU hMenu) 
{ 
	CheckMenuItem(hMenu, ID_PLAYLIST_SHOWDUPLICATE,  (bShowDuplicate == TRUE ? MF_BYCOMMAND | MF_CHECKED: MF_BYCOMMAND | MF_UNCHECKED));
} 

/* ************************************************************ */
void winamp_enqueue_to_playlist(BOOL bPlay)
{
	LVITEM lvi; 
	int i,nCount;
	char *file;
	MYITEM *pItem;
	COPYDATASTRUCT cds;
		
	ZeroMemory(&lvi, sizeof(lvi)); 
	lvi.mask = LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED; 

	nCount = ListView_GetItemCount(m_hwndList);
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);

		pItem = (MYITEM*)lvi.lParam;

		if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
		{
			if (bPlay)
				SendMessage(plugin.hwndParent, WM_USER, (WPARAM)NULL, 101);

			// Ajoute a la playlist la playlist Test.m3u identique pour un MP3 Titi.mp3
			file = (char*)pItem->pFileName;
			cds.dwData = 100;
			cds.lpData = (void*)file;
			cds.cbData = strlen((char*)cds.lpData)+1;
			SendMessage(plugin.hwndParent, WM_COPYDATA, (WPARAM)NULL,(LPARAM)&cds);

			if (bPlay)
			{
				// Set the 1st song and play
				SendMessage(plugin.hwndParent, WM_USER, (WPARAM)0, 121);
				SendMessage(plugin.hwndParent, WM_USER, (WPARAM)NULL, 102);
			}
		}
		
	}

}

/* ************************************************************ */
void winamp_enqueue_all_to_playlist(BOOL bPlay)
{
	int i, nCount;
	LV_ITEM lvi;
	MYITEM *pItem;
	COPYDATASTRUCT cds;
	int iItem;
	
	iItem = ListView_GetNextItem(m_hwndList, -1, LVNI_ALL | LVNI_SELECTED); 

	nCount = ListView_GetItemCount(m_hwndList);

	lvi.mask =  LVIF_PARAM; 

	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;

		cds.dwData = 100;
		cds.lpData = (void*)pItem->pFileName;;
		cds.cbData = strlen((char*)cds.lpData)+1;
		SendMessage(plugin.hwndParent, WM_COPYDATA, (WPARAM)NULL,(LPARAM)&cds);
	}

	if (bPlay)
	{
		SendMessage(plugin.hwndParent, WM_USER, (WPARAM)0, 121);
		SendMessage(plugin.hwndParent, WM_USER, (WPARAM)NULL, 102);
	}


}


/* ************************************************************ */
void LV_SelectAll(BOOL bSelect)
{
	ListView_SetItemState(m_hwndList, -1, (bSelect ? LVIS_SELECTED : 0) , LVIS_SELECTED);  
}

/* ************************************************************ */
void LV_SelectToggle(void)
{
	LVITEM lvi; 
	int i,nCount;

	ZeroMemory(&lvi, sizeof(lvi)); 
	lvi.mask = LVIF_STATE;
	lvi.stateMask = LVIS_SELECTED; 

	nCount = ListView_GetItemCount(m_hwndList);
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		ListView_SetItemState(m_hwndList, i, (lvi.state & LVIS_SELECTED)? 0: LVIS_SELECTED , LVIS_SELECTED);
	}

}

/* ************************************************************ */
void LV_SelectWithSame(int nCol)
{
	LV_ITEM lvi;
	int i, nCount, ret;
	MYITEM *pItem, ItemSame; 
	BOOL bSame;
	PLAYLISTSTRUCT *p1, *p2;

	// retreive information for the item selected
    i = ListView_GetNextItem(m_hwndList, -1, LVNI_SELECTED); 
    if (i < 0) 
		return;

	lvi.iItem = i; 
    lvi.iSubItem = 0; 
    lvi.mask = LVIF_PARAM; 

    ret = ListView_GetItem(m_hwndList, &lvi); 
	pItem = (MYITEM*)lvi.lParam;

	// Initialize MYITEM and copy the original MYTIEM (to be equal)
	nCount = sizeof(PLAYLISTSTRUCT);
	ItemSame.pData = p1 = (PLAYLISTSTRUCT*)LocalAlloc(LPTR, nCount);
	ItemSame.pFileName  = (LPSTR)LocalAlloc(LPTR, strlen(pItem->pFileName));
	
	memcpy((PLAYLISTSTRUCT*)p1, (PLAYLISTSTRUCT*)pItem->pData, nCount);
	lstrcpy((LPSTR)ItemSame.pFileName, (LPSTR)pItem->pFileName);
	
	// Unselect all item before
	LV_SelectAll(FALSE);

	// Scan all item in the listview
	nCount = ListView_GetItemCount(m_hwndList);
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;
		p2 = pItem->pData;

		// Check the good column ?
		bSame = FALSE;
		switch(nCol)
		{
		case 0: 
			ret = strcmp(p1->titleplaylist, p2->titleplaylist); 
			bSame = (ret == 0);
			break;
		case 1: 
			ret = strcmp(p1->title, p2->title); 
			bSame = (ret == 0);
			break;
		case 2: 
			bSame = (p1->genre == p2->genre); 
			break;
		case 3: 
			ret = strcmp(p1->year, p2->year); 
			bSame = (ret == 0);
			break;
		case 4: 
			ret = strcmp(p1->album, p2->album); 
			bSame = (ret == 0);
			break;
		case 5: 
			ret = strcmp(p1->comment, p2->comment); 
			bSame = (ret == 0);
			break;
		case 6: 
			bSame = (p1->mode == p2->mode); 
			break;
		case 7: 
			bSame = (p1->bitrate == p2->bitrate); 
			break;
		case 8: 
			bSame = (p1->frequency == p2->frequency); 
			break;
		case 9: 
			bSame = (p1->mode == p2->mode); 
			break;
		case 10: 
			bSame = (p1->mode == p2->mode); 
			break;
		case 11: 
			bSame = (p1->filesize == p2->filesize); 
			break;
		case 12: 
			ret = strcmp(ItemSame.pFileName, pItem->pFileName); 
			bSame = (ret == 0);
			break;
		default:
			bSame = FALSE;
			break;
		}

		
		ListView_SetItemState(m_hwndList, i, ((bSame)?LVIS_SELECTED:0), LVIS_SELECTED);
	}

	LocalFree(ItemSame.pData);
	LocalFree(ItemSame.pFileName);

}

/* ************************************************************ */
void LV_SelectCrop(void)
{
	LVITEM lvi; 
	int i,nCount, nSelCount;
	
	nSelCount = ListView_GetSelectedCount(m_hwndList);
	if (nSelCount < 1)
		return;

	LV_Redraw(FALSE);

	nCount = ListView_GetItemCount(m_hwndList);
	
	i = 0;
	while (nCount > nSelCount)
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);

		if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
			// skip select item
			i++;		
		else
		{
			// delete and clear data for unselect item
			Item_Delete((MYITEM*)lvi.lParam); 
			
			ListView_DeleteItem(m_hwndList, i);

			nCount--;
		}	
	}

	LV_UpdateStatus();
	LV_Redraw(TRUE);
	LV_StatGenre();
}

/* ************************************************************ */
void LV_SelectDel(void)
{
	LVITEM lvi; 
	int i, nSelCount;
	MYITEM *pItem;
	
	nSelCount = ListView_GetSelectedCount(m_hwndList);
	if (nSelCount < 1)
		return;

	LV_Redraw(FALSE);

	i = 0;
	while (nSelCount > 0)
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		
		pItem = (MYITEM*)lvi.lParam;
		
		if ((lvi.state & LVIS_SELECTED) != LVIS_SELECTED)
		{
			// skip unselect item
			i++;
		}
		else
		{
			// delete and clear data for unselect item
			Item_Delete(pItem); 
			
			ListView_DeleteItem(m_hwndList, i);

			nSelCount--;
		}	
	}

	// Selected the next item
	ZeroMemory(&lvi, sizeof(lvi)); 
	lvi.mask = LVIF_STATE; 
	lvi.stateMask = LVIS_SELECTED; 
	lvi.iItem  = i;
	ListView_SetItemState(m_hwndList, i, LVIS_SELECTED , LVIS_SELECTED);

	LV_UpdateStatus();
	LV_Redraw(TRUE);
	LV_StatGenre();
}

/* ************************************************************ */
void LV_UpdateStatus(void)
{
	LVITEM lvi; 
	int i,nCount;
	MYITEM *pItem;

	ZeroMemory(&lvi, sizeof(lvi)); 
	lvi.mask = LVIF_PARAM; 

	nCount = ListView_GetItemCount(m_hwndList);
	
	nTotalLength = 0;

	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;		
	
		nTotalLength += pItem->pData->length;
	}

	UpdateStatus(GetParent(m_hwndList));

}

/* ************************************************************ */
void LV_StatGenre(void)
{
	int i, idGenre;
	MYITEM *pItem;

	for (i = 0; i < MAX_GENRE; i++ )
	{
		gStatGenre[i].bCheck = FALSE;
		gStatGenre[i].nCount = 0;
	}
	
	// Scan all playlist  from memory 
	pItem = gpStartItem;

	while (pItem != NULL)
	{
		idGenre = pItem->pData->genre;
		
		if (idGenre>=0 && idGenre<MAX_GENRE)
		{
			gStatGenre[idGenre].bCheck = TRUE;
			gStatGenre[idGenre].nCount++;
		}
		
		pItem = pItem->pNextItem; 

	}

}

/* ************************************************************ */
void LV_UpdatePlaylist(HWND hwndDlg)
{
	char szSearch[40];
	LVITEM lvi; 
	int iItem, idGenre;
	MYITEM *pItem;
	BOOL bFind;

	char title[31];
	char album[31];
	char comment[31];
	LPSTR artist;
	LPSTR filename;

	LV_Redraw(FALSE);
	ListView_DeleteAllItems(m_hwndList); 
		
    // Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	nTotalLength = 0;
	
	// Scan all playlist  from memory 
	pItem = gpStartItem;
	iItem = 0;

	GetDlgItemText(hwndDlg, IDC_EDIT_SEARCH, (LPSTR)szSearch, 256);


	if (strlen(szSearch) != 0)
	{
		_strlwr(szSearch);

		while (pItem != NULL)
		{
			bFind = FALSE;

			// compare item in lowercase  
			strcpy(title, pItem->pData->title);
			strcpy(album, pItem->pData->album);
			strcpy(comment, pItem->pData->comment);
			artist = DupString(pItem->pData->titleplaylist);
			filename = DupString(pItem->pFileName);
			
			_strlwr(artist);
			_strlwr(title);
			_strlwr(album);
			_strlwr(comment);
			_strlwr(filename);
			
			if( (gParam.nOptionSearch & 1) && strstr(artist, szSearch)  != 0 ||
				(gParam.nOptionSearch & 2) && strstr(title, szSearch)   != 0 ||
				(gParam.nOptionSearch & 4) && strstr(album, szSearch) != 0 ||
				(gParam.nOptionSearch & 8) && strstr(comment, szSearch) != 0 ||
				(gParam.nOptionSearch & 16) && strstr(filename, szSearch) != 0 )
				bFind = TRUE;
			
			GlobalFree(artist);
			GlobalFree(filename);

			idGenre = pItem->pData->genre;
			
			if (gStatGenre[idGenre].bCheck && bFind)
			{
				// Initialize item-specific LVITEM members.         
				// Add the item.         
				lvi.iItem = iItem; 
				lvi.iSubItem = 0;         
				lvi.iImage = pItem->nImage; 
				lvi.lParam = (LPARAM) pItem;    // item data  
				ListView_InsertItem(m_hwndList, &lvi);  
				
				nTotalLength += pItem->pData->length;
			
				iItem++;
			}

			pItem = pItem->pNextItem; 
		}

	}
	else
	{
		while (pItem != NULL)
		{
			idGenre = pItem->pData->genre;
			
			if (gStatGenre[idGenre].bCheck)
			{
				// Initialize item-specific LVITEM members.         
				// Add the item.         
				lvi.iItem = iItem; 
				lvi.iSubItem = 0;         
				lvi.iImage = pItem->nImage; 
				lvi.lParam = (LPARAM) pItem;    // item data  
				ListView_InsertItem(m_hwndList, &lvi);  
				
				nTotalLength += pItem->pData->length;
			
				iItem++;
			}

			pItem = pItem->pNextItem; 
		}

	}


	LV_UpdateStatus();
	LV_Redraw(TRUE);
}

/* ************************************************************ */
void LV_ShowDuplicate(void)
{
	LVITEM lvi; 
	int iItem = 0;
	MYITEM *p1;
	MYITEM *p2;
	
	LV_Redraw(FALSE);
	ListView_DeleteAllItems(m_hwndList); 

	// Set all item FALSE duplicate
	p1 = gpStartItem;
	while (p1 != NULL)
	{
		p1->pData->bDuplicate = FALSE;
		p1 = p1->pNextItem;
	}


	// Scan all playlist from memory to detect duplicates
	p1 = gpStartItem;
	while (p1 != NULL)
	{
		p2 = p1->pNextItem;

		while (p2 != NULL)
		{
			
			if ((strcmp(p1->pData->artist, p2->pData->artist) == 0) &&
				(strcmp(p1->pData->title,  p2->pData->title ) == 0))
			{
				p1->pData->bDuplicate = TRUE; 			
				p2->pData->bDuplicate = TRUE;
			}
			p2 = p2->pNextItem; 
		}
		p1 = p1->pNextItem; 
	}

   

	// Initialize LVITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0;     
	lvi.iSubItem = 0;         
	lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 

	nTotalLength = 0;
	
	// Add result items in listview
	p1= gpStartItem;
	iItem = 0;
	while (p1 != NULL)
	{
		if (p1->pData->bDuplicate == TRUE) 
		{
			lvi.iItem = iItem; 
			lvi.iImage = p1->nImage; 
			lvi.lParam = (LPARAM) p1;    // item data  
			ListView_InsertItem(m_hwndList, &lvi);  
			
			nTotalLength += p1->pData->length;
			iItem++;
		}
		p1 = p1->pNextItem; 
	}

	LV_UpdateStatus();
	LV_Redraw(TRUE);
}


/* ************************************************************ */
void LV_DeadFiles(void)
{
	LVITEM lvi; 
	int i,nCount;
	MYITEM *pItem;
	DWORD attr;

	ZeroMemory(&lvi, sizeof(lvi)); 
	lvi.mask = LVIF_STATE | LVIF_PARAM; 
	lvi.stateMask = LVIS_SELECTED; 

	nCount = ListView_GetItemCount(m_hwndList);
	
	for (i = 0; i< nCount; i++)
	{
		lvi.iItem  = i;
		ListView_GetItem(m_hwndList, &lvi);
		pItem = (MYITEM*)lvi.lParam;    // item data  

		attr = GetFileAttributes(pItem->pFileName);
		
		ListView_SetItemState(m_hwndList, i, (attr == 0xFFFFFFFF) ? LVIS_SELECTED : 0 , LVIS_SELECTED);
	}
}


/* ************************************************************ */
void LV_Redraw(BOOL bUpdate)
{
	//turn the listview's redrawing on/off 
	
	SendMessage(m_hwndList, WM_SETREDRAW, bUpdate, 0); 
	
	if (bUpdate)
	{
		//turn the listview's redrawing back on and force it to draw 
		SendMessage(m_hwndList, WM_SETREDRAW, TRUE, 0); 
		InvalidateRect(m_hwndList, NULL, TRUE); 
		UpdateWindow(m_hwndList); 
	}
}




/* ************************************************************ */
long GetVolume(void)
{  
	UINT uDevId, uDevNum; 
	WAVEOUTCAPS  woc; 
	MMRESULT mmr;
    
    uDevNum = waveOutGetNumDevs();
    
    for( uDevId = 0; uDevId< uDevNum; uDevId++)
   	{
    	mmr = waveOutGetDevCaps(uDevId, &woc, sizeof(woc)); 
		if (woc.dwSupport & WAVECAPS_VOLUME)
		{
			DWORD dwVolume;
			DWORD dwVol;

			waveOutGetVolume( (HWAVEOUT)uDevId, &dwVolume);

			dwVol = LOWORD(dwVolume);
			dwVol *= 255;
			dwVol = dwVol / 65535;
			
	       	return ((long)dwVol);
     	}
  
	}   
	return (0L);
}

/* ************************************************************ */
void SetFilter(char *szFilter)
{
	// Use for OPENFILENAME 
	char chReplace;
	UINT u;

    chReplace  = szFilter[strlen(szFilter) - 1];
    for (u = 0; szFilter[u] != '\0'; u++)
        if (szFilter[u] == chReplace)
            szFilter[u] = '\0';
}


//
//
// List chainees MYITEM

/* ************************************************************ */
MYITEM * Item_New(MYITEM *pLast, LPSTR lpszFileName)
{
	MYITEM *pNew;
	PLAYLISTSTRUCT *pNewData;
	LPSTR lpszNewFileName;
	int cb;
	
	cb = lstrlen(lpszFileName) + 1;

	pNew = (MYITEM*)GlobalAlloc(LMEM_FIXED, sizeof(MYITEM));
	if(pNew == NULL) return NULL;

	pNewData = (PLAYLISTSTRUCT*)GlobalAlloc(LMEM_FIXED, sizeof(PLAYLISTSTRUCT));
	if(pNewData == NULL) return NULL;

	lpszNewFileName = (LPSTR)GlobalAlloc(LMEM_FIXED, cb);
	if(lpszNewFileName == NULL) return NULL;

	CopyMemory(pNewData, &gPlayList,  sizeof(PLAYLISTSTRUCT));
	CopyMemory(lpszNewFileName, lpszFileName,  cb);
	pNew->pData = pNewData;
	pNew->pFileName =lpszNewFileName;
	pNew->pNextItem = NULL;
	pNew->pPrevItem = pLast;

	if (pLast == NULL)
		gpStartItem = pNew;
	else
		pLast->pNextItem = pNew;

	return(pNew);
}


/* ************************************************************ */
MYITEM * Item_Delete(MYITEM *pDel)
{
	MYITEM *pPrev, *pNext;
	
	pPrev = pDel->pPrevItem;
	pNext = pDel->pNextItem;

	// Free block data item
	GlobalFree(pDel->pData->titleplaylist);
	GlobalFree(pDel->pData);
	GlobalFree(pDel->pFileName);

	if (pPrev == NULL && pNext == NULL)
	{
		gpStartItem = NULL;
		return(gpStartItem);
	}
	// Debut de liste
	if (pPrev == NULL)
	{
		gpStartItem = pNext;
		pNext->pPrevItem = NULL;
		return(pNext);
	}
	// Fin de liste
	else if (pNext == NULL)
	{
		pPrev->pNextItem = NULL;
		return(pPrev);
	}

	// Milieu de liste
	else
	{
		pPrev->pNextItem = pNext;
		pNext->pPrevItem = pPrev;
		return(pPrev);
	}

}

/* ************************************************************ */
int Item_DeleteAll(void)
{
	MYITEM *pCur;
	int n = 0;
	
	pCur = gpStartItem;
	
	while (pCur != NULL)
	{
		pCur = Item_Delete(pCur); 
		n++;
	}

	return (n);
}

/* ************************************************************ */
MYITEM* Item_GetLast(void)
{
	MYITEM *pCur = gpStartItem;

	if (pCur == 0)
		return (pCur);

	while (pCur->pNextItem != NULL)
		pCur = pCur->pNextItem;
	
	return (pCur);
}

/**************************************************************************** */
// DupString - allocates a copy of a string. 
// lpsz - address of the null-terminated string to copy.  
LPSTR DupString(LPSTR lpsz) 	
{     
	int cb = lstrlen(lpsz) + 1; 
    LPSTR lpszNew = GlobalAlloc(LMEM_FIXED, cb);     
	if (lpszNew != NULL) 
        CopyMemory(lpszNew, lpsz, cb);     
	
	return lpszNew; 	
} 

/* *********************************************************** */ 
char *GetFormattedDateTime(void) 
{ 
	static char szTime[64]; 
    int cch = 0; 
 
 	// Date format
	cch = GetDateFormat( 
	        LOCALE_USER_DEFAULT, 
	        0, 
	        NULL,			// current date 
	        "yyyy/MM/dd",   
	        szTime, 
	        sizeof szTime); 
 
    // cch includes null terminator, change it to 
    // a space to separate from time. 
    szTime[ cch - 1 ] = ' '; 
    
 	// Time format
    GetTimeFormat( 
	    LOCALE_USER_DEFAULT, 
	    TIME_NOSECONDS, 
	    NULL,   // use current time 
	    NULL,   // use default format 
	    szTime + cch, 
	    (sizeof szTime) - cch ); 
 
    return szTime; 
} 
 

/*************************************************************
* Update the status bar
**************************************************************/
void UpdateStatus(HWND hDlg)
{
	CHAR szTemp[255];
	CHAR szTime[80];
	int nTotalFile =	ListView_GetItemCount(m_hwndList);

	wsprintf(szTemp,"Total files: %i", nTotalFile);
	ST_ChangeText((LPSTR)szTemp, 0);

	if (nTotalFile != 0)
		nAvgLength = nTotalLength / nTotalFile;
	else
		nAvgLength = 0;

	Time2String(nAvgLength, szTime, TRUE);
	wsprintf(szTemp,"Avg length: %s", szTime);
	ST_ChangeText((LPSTR)szTemp, 1);

	Time2String(nTotalLength, szTime, FALSE);
	wsprintf(szTemp,"Total length: %s", szTime);
	ST_ChangeText((LPSTR)szTemp, 2);
}


/* ************************************************************** */
void  ListboxMoveItem(HWND hwndlist, BOOL bMoveUp)
{
	int nCount, i;
	char szTmp[40];
	int pos1, pos2;

	nCount = SendMessage(hwndlist, LB_GETCOUNT, 0, 0);

	i = SendMessage(hwndlist, LB_GETCURSEL, 0, 0);

	if (i == LB_ERR) 
		return;
	if (nCount == 0)
		return;
	if (i <= 0 && bMoveUp == TRUE)
		return;
	if ((i+1) >= nCount && bMoveUp== FALSE)
		return;

	if (bMoveUp == FALSE)
	{
		pos1 = i;	pos2 = i+1;
	}
	else
	{
		pos1 = i;	pos2 = i-1;
	}
	
	// get the string from the listbox
	SendMessage(hwndlist,LB_GETTEXT, pos1, (LPARAM)szTmp);	
	// Delete old Item
	SendMessage(hwndlist,LB_DELETESTRING, pos1, 0);
	// insert Item at new position
	i=pos2;
	if (i >= SendMessage(hwndlist,LB_GETCOUNT, 0, 0)) 
		i = -1;	// if last item, append tstring
	SendMessage(hwndlist,LB_INSERTSTRING, i, (LPARAM)szTmp);
	SendMessage(hwndlist,LB_SETCURSEL, pos2, 0);

}


