#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>			//memset
#include "EZPlaylist.h"
#include "ID3TAG.h"
#include "dxhead.h"



// WAVE TAG
//#define	WAVE_FORMAT_PCM			(0x0001)  macro redefinition
#define	WAVE_FORMAT_UNKNOWN		(0x0000)
#define	WAVE_FORMAT_ADPCM		(0x0002)
#define	WAVE_FORMAT_ALAW		(0x0006)
#define	WAVE_FORMAT_MULAW		(0x0007)
#define	WAVE_FORMAT_OKI_ADPCM	(0x0010)
#define	WAVE_FORMAT_DIGISTD		(0x0015)
#define	WAVE_FORMAT_DIGIFIX		(0x0016)
#define	IBM_FORMAT_MULAW        (0x0101)
#define	IBM_FORMAT_ALAW			(0x0102)
#define	IBM_FORMAT_ADPCM        (0x0103)

// MP3 TAG / VARIABLES
#define MPG_MD_STEREO           0
#define MPG_MD_JOINT_STEREO     1
#define MPG_MD_DUAL_CHANNEL     2
#define MPG_MD_MONO             3
#define MAXFRAMESIZE 1792

#define IsID3Tag(s) (s[0] == 'T' && s[1] == 'A' && s[2] == 'G')

STATGENRESTRUCT gStatGenre[MAX_GENRE];

const char *mp3_genres[MAX_GENRE] =
{
	"???",
	"Blues", "Classic Rock", "Country", "Dance",
	"Disco", "Funk", "Grunge", "Hip-Hop",
	"Jazz", "Metal", "New Age", "Oldies",
	"Other", "Pop", "R&B", "Rap", "Reggae",
	"Rock", "Techno", "Industrial", "Alternative",
	"Ska", "Death Metal", "Pranks", "Soundtrack",
	"Euro-Techno", "Ambient", "Trip-Hop", "Vocal",
	"Jazz+Funk", "Fusion", "Trance", "Classical",
	"Instrumental", "Acid", "House", "Game",
	"Sound Clip", "Gospel", "Noise", "Alt",
	"Bass", "Soul", "Punk", "Space",
	"Meditative", "Instrumental Pop",
	"Instrumental Rock", "Ethnic", "Gothic",
	"Darkwave", "Techno-Industrial", "Electronic",
	"Pop-Folk", "Eurodance", "Dream",
	"Southern Rock", "Comedy", "Cult",
	"Gangsta Rap", "Top 40", "Christian Rap",
	"Pop/Funk", "Jungle", "Native American",
	"Cabaret", "New Wave", "Psychedelic", "Rave",
	"Showtunes", "Trailer", "Lo-Fi", "Tribal",
	"Acid Punk", "Acid Jazz", "Polka", "Retro",
	"Musical", "Rock & Roll", "Hard Rock", "Folk",
	"Folk/Rock", "National Folk", "Swing",
	"Fast-Fusion", "Bebob", "Latin", "Revival",
	"Celtic", "Bluegrass", "Avantgarde",
	"Gothic Rock", "Progressive Rock",
	"Psychedelic Rock", "Symphonic Rock", "Slow Rock",
	"Big Band", "Chorus", "Easy Listening",
	"Acoustic", "Humour", "Speech", "Chanson",
	"Opera", "Chamber Music", "Sonata", "Symphony",
	"Booty Bass", "Primus", "Porn Groove",
	"Satire", "Slow Jam", "Club", "Tango",
	"Samba", "Folklore", "Ballad", "Power Ballad",
	"Rhythmic Soul", "Freestyle", "Duet",
	"Punk Rock", "Drum Solo", "A Cappella",
	"Euro-House", "Dance Hall", "Goa",
	"Drum & Bass", "Club-House", "Hardcore",
	"Terror", "Indie", "BritPop", "Negerpunk",
	"Polsk Punk", "Beat", "Christian Gangsta Rap",
	"Heavy Metal", "Black Metal", "Crossover",
	"Contemporary Christian", "Christian Rock",
	"Merengue", "Salsa", "Trash Metal",
	"Anime", "JPop", "Synthpop"
};

#define MAX_MODE 4
const char *mp3_mode[MAX_MODE] = {"Stereo", "Join Stereo", "Dual channel", "Mono"};
const char *emphasis[4] = {"None", "50/15 ms", " ", "CCIT J.17"};
const char *bool_label[2] = {"No", "Yes"};

int tabsel_123[2][3][16] =
{
	{{0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448,},
       {0, 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384,},
       {0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320,}},
	{{0, 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256,},
	    {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160,},
	    {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160,}}
};

long mpg123_freqs[9] =
	{44100, 48000, 32000, 22050, 24000, 16000, 11025, 12000, 8000};




PLAYLISTSTRUCT gPlayList;


/* ****************************************************** */
void mpg123_init(void)
{
	memset(&gPlayList, 0, sizeof(gPlayList));
	
	gPlayList.genre = 0;
	gPlayList.mpeg25 = -1;
	gPlayList.lay = 0;
	gPlayList.lsf = 0;
	gPlayList.track = 0;
}

/* ****************************************************** */	
int mpg123_file_info(char *filename)
{
	char *ext;

	mpg123_init();
	

	/* We assume all http:// are mpeg -- why do we do that? */
	if (!strncmp(filename, "http://", 7))
	{	
		gPlayList.titleplaylist = DupString(filename);
		return 2;
	}

	ext = strrchr(filename, '.');
	if (ext != NULL)
		ext = _strlwr(ext);

	if (ext)
	{
		if (!strncmp(ext, ".mp3", 4) ||
			!strncmp(ext, ".mp2", 4) || 
			!strncmp(ext, ".mp1", 4))
		{	mpg123_read_mp3(filename);
			return 0;
		}
		if (!strncmp(ext, ".wav", 4))
		{	mpg123_read_wav(filename);
			return 1;
			
		}
	}
	return -1;
}	

/* ****************************************************** */
void mpg123_read_mp3(char *filename)
{
	PLAYLISTSTRUCT *frm = &gPlayList;
	ID3TAGSTRUCT tag;
	FILE *file;
	char *p;
	char *temp; 

	if ((file = fopen(filename, "rb")) == NULL)
	{
		temp = strrchr(filename, '\\');
		if (!temp)
			temp = filename;
		else
			temp++;
		
		frm->titleplaylist = DupString(temp);
		p = frm->titleplaylist;	
		*p = toupper(*p);
	}
	else
	{
		unsigned long  head;
		unsigned char tmp[4];
		BOOL id3_found = FALSE;

		fseek(file, -128, SEEK_END);
		if (fread(&tag, 1, sizeof (tag), file) == sizeof (tag))
		{
			if (!strncmp(tag.tag, "TAG", 3))
			{
				id3_found = TRUE;
			
				mpg123_copytag(frm->title, tag.title, 30);
				mpg123_copytag(frm->artist,tag.artist, 30);
				mpg123_copytag(frm->album, tag.album, 30);
				mpg123_copytag(frm->year, tag.year, 4);
				mpg123_copytag(frm->comment, tag.comment, 30);	
				
				++tag.genre;	
				frm->genre =  tag.genre;
				gStatGenre[tag.genre].bCheck = TRUE;
				gStatGenre[tag.genre].nCount++;

				// now the track-field 
				if (tag.comment[28] == '\0')
					frm->track = tag.comment[29];
				else
					frm->track = 0;


				if (frm->artist[0] == '\0')
					strcpy(frm->artist, "Unkown Artist");
				if (frm->title[0] == '\0')
					strcpy(frm->title, "Untitled");

				frm->titleplaylist = DupString(frm->artist);
			}

			else
			{
				// Si il n'existe pas de TAG ID3v1
				// analyse le nom du fichier "Artist" - "title".mp3
				temp = strrchr(filename, '\\');
				if (!temp)
					temp = filename;
				else
					temp++;

				frm->titleplaylist = DupString(temp);
				p = frm->titleplaylist;	
				*p = toupper(*p);
				
			}
		}

		
		p = frm->artist;	
		*p = toupper(*p);
		
		p = frm->title;		
		*p = toupper(*p);
					

		rewind(file);
		if (fread(tmp, 1, 4, file) != 4)
		{	fclose(file);
			return;
		}

		
		head =	((unsigned long) tmp[0] << 24) | 
				((unsigned long) tmp[1] << 16) | 
				((unsigned long) tmp[2] << 8) | 
				(unsigned long) tmp[3];

		while (!mpg123_head_check(head))
		{
			head <<= 8;
			if (fread(tmp, 1, 1, file) != 1)
			{	fclose(file);
				return;
			}
			head |= tmp[0];
		}
		if (mpg123_decode_header(frm, head))
		{
			unsigned char *buf;
			double tpf, bpf;
			unsigned long len;
			XHEADDATA xing_header;
			
			buf = (unsigned char*)malloc(frm->framesize + 4);
			fseek(file, -4, SEEK_CUR);
			fread(buf, 1, frm->framesize + 4, file);
			xing_header.toc = NULL;
			
			tpf = mpg123_compute_tpf(frm);
			bpf = mpg123_compute_bpf(frm);

			fseek(file, 0, SEEK_END);
			len = ftell(file);
			frm->filesize  = len;

			if (mpg123_get_xing_header(&xing_header, buf))
			{
				frm->num_frames = xing_header.frames;
				frm->bitrate = (int) ((xing_header.bytes * 8) / (tpf * frm->num_frames * 1000));
			}
			else
			{
				if (id3_found)
					len -= 128;
		
				frm->num_frames = (int) ((len) / bpf + 1);
				frm->bitrate = tabsel_123[frm->lsf][frm->lay - 1][frm->bitrate_index];
			}

			frm->frequency = mpg123_freqs[frm->sampling_frequency];

			frm->length = frm->num_frames * tpf;
			
			//formated zone time
			Time2String(frm->length, frm->lengthfmt, TRUE);

			free(buf);
		}
		fclose(file);
	}

}



/* ****************************************************** */
int mpg123_head_check(unsigned long head)
{
	if ((head & 0xffe00000) != 0xffe00000)
		return FALSE;
	if (!((head >> 17) & 3))
		return FALSE;
	if (((head >> 12) & 0xf) == 0xf)
		return FALSE;
	if (!((head >> 12) & 0xf))
		return FALSE;
	if (((head >> 10) & 0x3) == 0x3)
		return FALSE;
	if (((head >> 19) & 1) == 1 && ((head >> 17) & 3) == 3 && ((head >> 16) & 1) == 1)
		return FALSE;
	if ((head & 0xffff0000) == 0xfffe0000)
		return FALSE;
	
	return TRUE;
}

/* *************************************************************************
 * the code a header and write the information
 * into the frame structure
 */
int mpg123_decode_header(PLAYLISTSTRUCT *fr, unsigned long newhead)
{
	if (newhead & (1 << 20))
	{
		fr->lsf = (newhead & (1 << 19)) ? 0x0 : 0x1;
		fr->mpeg25 = 0;
	}
	else
	{
		fr->lsf = 1;
		fr->mpeg25 = 1;
	}
	fr->lay = 4 - ((newhead >> 17) & 3);
	if (fr->mpeg25)
	{
		fr->sampling_frequency = 6 + ((newhead >> 10) & 0x3);
	}
	else
		fr->sampling_frequency = ((newhead >> 10) & 0x3) + (fr->lsf * 3);
	fr->error_protection = ((newhead >> 16) & 0x1) ^ 0x1;

	if (fr->mpeg25)		/* allow Bitrate change for 2.5 ... */
		fr->bitrate_index = ((newhead >> 12) & 0xf);

	fr->bitrate_index = ((newhead >> 12) & 0xf);
	fr->privat = ((newhead >> 8) & 0x1);
	fr->padding = ((newhead >> 9) & 0x1);
	fr->extension = ((newhead >> 8) & 0x1);
	fr->mode = ((newhead >> 6) & 0x3);
	fr->mode_ext = ((newhead >> 4) & 0x3);
	fr->copyright = ((newhead >> 3) & 0x1);
	fr->original = ((newhead >> 2) & 0x1);
	fr->emphasis = newhead & 0x3;

	fr->stereo = (fr->mode == MPG_MD_MONO) ? 1 : 2;

	if (!fr->bitrate_index)
		return (0);

	switch (fr->lay)
	{
		case 1:
			fr->framesize = (long) tabsel_123[fr->lsf][0][fr->bitrate_index] * 12000;
			fr->framesize /= mpg123_freqs[fr->sampling_frequency];
			fr->framesize = ((fr->framesize + fr->padding) << 2) - 4;
			break;
		case 2:
			fr->framesize = (long) tabsel_123[fr->lsf][1][fr->bitrate_index] * 144000;
			fr->framesize /= mpg123_freqs[fr->sampling_frequency];
			fr->framesize += fr->padding - 4;
			break;
		case 3:
			fr->framesize = (long) tabsel_123[fr->lsf][2][fr->bitrate_index] * 144000;
			fr->framesize /= mpg123_freqs[fr->sampling_frequency] << (fr->lsf);
			fr->framesize = fr->framesize + fr->padding - 4;
			break;
		default:
			return (0);
	}
	if(fr->framesize > MAXFRAMESIZE)
		return 0;
	return 1;
}

/* ************************************************************************ */
double mpg123_compute_bpf(PLAYLISTSTRUCT *fr)
{
	double bpf;

	switch (fr->lay)
	{
		case 1:
			bpf = tabsel_123[fr->lsf][0][fr->bitrate_index];
			bpf *= 12000.0 * 4.0;
			bpf /= mpg123_freqs[fr->sampling_frequency] << (fr->lsf);
			break;
		case 2:
		case 3:
			bpf = tabsel_123[fr->lsf][fr->lay - 1][fr->bitrate_index];
			bpf *= 144000;
			bpf /= mpg123_freqs[fr->sampling_frequency] << (fr->lsf);
			break;
		default:
			bpf = 1.0;
	}

	return bpf;
}

/* ****************************************************** */
double mpg123_compute_tpf(PLAYLISTSTRUCT *fr)
{
	static int bs[4] =	{0, 384, 1152, 1152};
	double tpf;

	tpf = (double) bs[fr->lay];
	tpf /= mpg123_freqs[fr->sampling_frequency] << (fr->lsf);
	return tpf;
}

/* ************************************************************************ */
int mpg123_calc_numframes(PLAYLISTSTRUCT *fr)
{
	return (int) (fr->filesize / mpg123_compute_bpf(fr));
}



/* ****************************************************** */
void mpg123_read_wav(char *filename)
{
	char magic[4], *temp;
	unsigned long len;
	int rate;
	
	short format_tag, channels, block_align, bits_per_sample;
	long samples_per_sec, avg_bytes_per_sec;
	
	FILE *file;

	if (!(file = fopen(filename, "rb")))
		return;

	fread(magic, 1, 4, file);
	if (strncmp(magic, "RIFF", 4))
	{	fclose(file);
		return;
	}
	
	read_le_long(file, &len);
	fread(magic, 1, 4, file);
	if (strncmp(magic, "WAVE", 4))
	{
		fclose(file);
		return;
	}

	for (;;)
	{
		fread(magic, 1, 4, file);
		if (!read_le_long(file, &len))
		{	fclose(file);
			return;
		}
		if (!strncmp("fmt ", magic, 4))
			break;
		fseek(file, len, SEEK_CUR);
	}
	if (len < 16)
	{	fclose(file);
		return;
	}
	read_le_short(file, &format_tag);
	switch (format_tag)
	{
		case WAVE_FORMAT_UNKNOWN:
		case WAVE_FORMAT_ALAW:
		case WAVE_FORMAT_MULAW:
		case WAVE_FORMAT_ADPCM:
		case WAVE_FORMAT_OKI_ADPCM:
		case WAVE_FORMAT_DIGISTD:
		case WAVE_FORMAT_DIGIFIX:
		case IBM_FORMAT_MULAW:
		case IBM_FORMAT_ALAW:
		case IBM_FORMAT_ADPCM:
			fclose(file);
			return;
	}
	read_le_short(file, &channels);
	read_le_long(file, &samples_per_sec);
	read_le_long(file, &avg_bytes_per_sec);
	read_le_short(file, &block_align);
	read_le_short(file, &bits_per_sample);
	
	if (bits_per_sample != 8 && bits_per_sample != 16)
	{
		fclose(file);
		return;
	}
	len -= 16;
	if (len)
		fseek(file, len, SEEK_CUR);

	for (;;)
	{
		fread(magic, 4, 1, file);

		if (!read_le_long(file, &len))
		{
			fclose(file);
			return;
		}
		if (!strncmp("data", magic, 4))
			break;
		fseek(file, len, SEEK_CUR);
	}

	rate = samples_per_sec * channels * (bits_per_sample / 8);

	
	temp = strrchr(filename, '\\');
	if (!temp)
		temp = filename;
	else
		temp++;


	fseek(file, 0, SEEK_END);
	len = ftell(file);
	gPlayList.filesize  = len;
	gPlayList.titleplaylist = DupString(temp);
	gPlayList.length = (len / rate);
	gPlayList.bitrate = 8 * rate;
	gPlayList.frequency = samples_per_sec;

	//formated zone time
	Time2String(gPlayList.length, gPlayList.lengthfmt, TRUE);

	fclose(file);
	
}

/* ****************************************************** */
/* needed for mpg123_read_wav */
int read_le_long(FILE * file, long *ret)
{
	unsigned char buf[4];

	if (fread(buf, 1, 4, file) != 4)
		return 0;

	*ret = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	return TRUE;
}
/* ****************************************************** */
/* needed for mpg123_read_wav */
int read_le_short(FILE * file, short *ret)
{
	unsigned char buf[2];

	if (fread(buf, 1, 2, file) != 2)
		return 0;

	*ret = (buf[1] << 8) | buf[0];
	return TRUE;
}



/* ****************************************************** */
const char *get_id3_genre(unsigned char g)
{
	return (mp3_genres[((g>= 0 && g < MAX_GENRE) ? g : 0)]);
}

/* ****************************************************** */
int find_genre_id(char *text)
{
	int i;

	for (i = 0; i < MAX_GENRE; i++)
	{
		if (!strcmp(mp3_genres[i], text))
			return i;
	}
	if (text[0] == '\0')
		return 0xff;
	return 0;
}

/* ****************************************************** */
void get_layer_mode(PLAYLISTSTRUCT *frm, char *tempstr)
{
	switch(frm->mpeg25)
	{
	case 0:
		sprintf(tempstr, "MPEG %d, layer %d", frm->lsf + 1, frm->lay);
		break;
	case 1:
		sprintf(tempstr, "MPEG 2.5, layer %d", frm->lay);
		break;
	default:
		strcpy(tempstr,"");
		break;
	}
}

/* ****************************************************** */
const char *get_mode(int mode_code)
{
	if (mode_code == -1)
		return  ("");

	
	return (mode_code < MAX_MODE)
		? mp3_mode[mode_code]
		: "";
};


/* ****************************************************** */
void mpg123_copytag(char *dest, char *src, size_t n)
{
	int stripped_len;
	
	stripped_len = mpg123_strip_spaces(src, n);
	memcpy(dest, src, n);
	*(dest+n) = '\0';
}

/* ****************************************************** */
/* strips trailing spaces from string of length n
 *  returns length of adjusted string 
 */
unsigned int mpg123_strip_spaces(char *src, size_t n)
{
	char *space = NULL;	/* last space in src */
	char *start = src;

	while (n--)
		switch (*src++)
		{
			case '\0':
				n = 0;	/* breaks out of while loop */
				src--;
				break;
			case ' ':
				if (space == NULL)
					space = src - 1;
				break;
			default:
				space = NULL;	/* don't terminate intermediate spaces */
				break;
		}
		
	if (space != NULL)
	{
		src = space;
		*src = '\0';
	}
	return src - start;
}


/* ******************************************************** */
void Time2String(int nSecond, char *pTimeFrmt, BOOL bShortFormat)
{
	int s, m, h;
	s = m = h = 0;
	
	s = nSecond % 60;
	m = nSecond / 60;
	h = m / 60;
	m = m % 60;

	if (bShortFormat)
	{
		if (h == 0)
			sprintf(pTimeFrmt, "%02d:%02d", m,s);
		else
			sprintf(pTimeFrmt, "%02d:%02d:%02d", h, m,s);
	}
	else
	{
		if (h == 0)
			sprintf(pTimeFrmt, "%02d minutes and %02d seconds", m,s);
		else
			sprintf(pTimeFrmt, "%02d hours %02d minutes and %02d seconds", h, m,s);
	}
}


/* ******************************************************** */
void mpg123_MPEGInfo(PLAYLISTSTRUCT *frm, char *mpeginfo, int nBlock)
{
	if (nBlock == 0)
	{
		char szLayerMode[80];
		get_layer_mode(frm, szLayerMode);

		sprintf(mpeginfo, 
			"Size: %d bytes\r\nLength: %lu seconds\r\n%s\r\n%dkbits, %d frames\r\n%dhz %s",						
			frm->filesize,
			frm->length,
			szLayerMode,
			frm->bitrate,
			frm->num_frames,
			frm->frequency,
			get_mode(frm->mode));
	}
	else
	{
		sprintf(mpeginfo, "Private: %s\r\nCRCs: %s\r\nCopyrighted: %s\r\nOriginal: %s\r\nEmphasis: %s",
			bool_label[frm->privat], 
			bool_label[frm->error_protection], 
			bool_label[frm->copyright], 
			bool_label[frm->original], 
			emphasis[frm->emphasis]);
		
	}
		  
}




//
// ID3 Tag
// 


/* ************************************************************************ */
BOOL id3tag_read(char *filename, ID3TAGSTRUCT *id3tag)
{
	FILE *file;
	BOOL id3found = FALSE;

	if ((file=fopen(filename, "rb")) == NULL)
		return(FALSE);

	if ((fseek(file, -128, SEEK_END) == 0) &&
		 fread(id3tag, 1, sizeof(ID3TAGSTRUCT), file)== sizeof(ID3TAGSTRUCT) &&
		 strncmp(id3tag->tag, "TAG", 3)==0)
	{
		id3found = TRUE;
	}
	fclose(file);	
	return id3found;
		
}

/* ************************************************************************ */
// write an ID3v1 structure in the file
BOOL id3tag_write(char *filename, ID3TAGSTRUCT *id3tag)
{
	FILE *file;
	size_t nbyteWritten = 0;
	
	// set the IDTAG 
	id3tag->tag[0] = 'T';
	id3tag->tag[1] = 'A';
	id3tag->tag[2] = 'G';

	if (!(file = id3tag_seekend(filename))) 
		return(FALSE);	// error

	nbyteWritten = fwrite(id3tag->tag, sizeof(ID3TAGSTRUCT), 1, file);
	if (nbyteWritten == 0)
		nbyteWritten = 1;

	fclose(file);

	return(nbyteWritten != 0);
}

/* ************************************************************************ */
int id3tag_remove(char *filename)
{
	FILE *file;

	if (!(file = id3tag_seekend(filename))) 
		return(FALSE);	// error

	{
		long offset;		// remeber the offset in the file
		HANDLE wfh;

		offset = ftell(file);
		fclose(file);

		if ((wfh = CreateFile(filename,	GENERIC_WRITE|GENERIC_READ,
						FILE_SHARE_READ|FILE_SHARE_WRITE, NULL,
						OPEN_EXISTING,	FILE_ATTRIBUTE_NORMAL|FILE_FLAG_RANDOM_ACCESS,
						NULL))
						== INVALID_HANDLE_VALUE)
			return(FALSE);		// error
		
		SetFilePointer(wfh, offset, NULL, FILE_BEGIN);
		SetEndOfFile(wfh);
		CloseHandle(wfh);
	}

	fclose(file);

	return(TRUE);	// OK remove TAG
}

/* ************************************************************************ */
FILE* id3tag_seekend(char *filename)
{
	FILE *file;
	char tag[3];
	size_t readbytes;

	if ((file=fopen(filename, "r+b")) == NULL)
		return(NULL);

	// ok, file is open, now look if there is a tag
	if ((fseek(file, -128, SEEK_END) == 0) &&
		 (readbytes = fread(tag, 1, sizeof(tag), file)) &&
		 readbytes == sizeof(tag) &&
		 IsID3Tag(tag))
	{
		// there already exists an id3-Tag
		fseek(file, -128, SEEK_END);
	}
	else 
		fseek(file, 0, SEEK_END);

	return (file);
}
