// Winamp general purpose plug-in mini-SDK
// Copyright (C) 1997, Justin Frankel/Nullsoft

#include <windows.h>
#include <process.h>

#include <commctrl.h>
#include <prsht.h>

#include "gen.h"
#include "resource.h"
#include "EZPlayList.h"
#include "DlgColumn.h"
#include "DlgTag.h"


BOOL StartEZPlaylist(HANDLE hInstance);
BOOL InitApplication(HANDLE hInstance);
BOOL InitWindows(HANDLE hInstance, int nCmdShow) ;


/* ************************************************************************ */
//BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
BOOL WINAPI DllMain(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

#define ENABLE_PREV 1
#define ENABLE_PLAY 2
#define ENABLE_STOP 4
#define ENABLE_NEXT 8
#define ENABLE_EJECT 16
#define ENABLE_VOLUP 32
#define ENABLE_EZLIST 64

int config_enabled=1;

BOOL gbOpenDlg = FALSE;



HICON Icons[7];
char *tips[7] = 
{
	"EZ-Playlist - Winamp",
	"Previous Track - Winamp",
	"Play/Pause - Winamp",
	"Stop - Winamp",
	"Next Track - Winamp",
	"Open File - Winamp",
	"Volume - Winamp"
};

HWND ghWndMain = NULL;

// from systray.c
extern BOOL systray_add(HWND hwnd, UINT uID, HICON hIcon, LPSTR lpszTip);
extern BOOL systray_del(HWND hwnd, UINT uID);




void config();
void quit();
int init();
void config_write();
void config_read();
char szAppName[] = "EZ-PlayList";

winampGeneralPurposePlugin plugin =
{
	GPPHDR_VER,
	"",
	init,
	config,
	quit,
};

/* ************************************************************************ */
void do_icons()
{
	static int l=0;
	int i;
	if (l == config_enabled) return;
	for (i = 6; i >= 0; i --)
	{
		if (l & (1<<i))
			systray_del(plugin.hwndParent,i);
	}
	
	l = config_enabled;	
	for (i = 0; i < 7; i ++)
	{
		if (config_enabled & (1<<i))
			systray_add(plugin.hwndParent,i,Icons[i],tips[i]);
	}
}

/* ************************************************************************ */
void config()
{
	DialogBox(plugin.hDllInstance,MAKEINTRESOURCE(IDD_DLGCONFIGURE),plugin.hwndParent,ConfigProc);
}

/* ************************************************************************ */
void quit()
{
	config_write();
	config_enabled=0;
	do_icons();
}

/* ************************************************************************ */
void *lpWndProcOld;
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_USER+27)
	{
		int which = LOWORD(wParam) - 1024,a;
		switch (LOWORD(lParam))
		{
			case WM_LBUTTONDOWN:
				switch (which)
				{
				// //////////////	
				// EZPlayList
				case 0:
					StartEZPlaylist(plugin.hDllInstance);
					return 0;
		
				// //////////////
				// Previous track
				case 1: 
					// not playing, let's hit prev
					if ((a=SendMessage(hwnd,WM_USER,0,104)) == 0) 
						// Previous
						SendMessage(hwnd,WM_COMMAND,40044,0);
					else if (a != 3 && SendMessage(hwnd,WM_USER,0,105) > 2000) // restart
						//Play
						SendMessage(hwnd,WM_COMMAND,40045,0);
					else 
						// previous
						SendMessage(hwnd,WM_COMMAND,40044,0);

					return 0;
				
				// //////////////
				// PLAY/PAUSE
				case 2: 
					// not playing, let's hit play
					if ((a=SendMessage(hwnd,WM_USER,0,104)) != 1) 
						SendMessage(hwnd,WM_COMMAND,40045,0);
					else { // prev
						SendMessage(hwnd,WM_COMMAND,40046,0);
					}
					return 0;
				
				// //////////////
				// Stop 
				case 3: 
					if (GetKeyState(VK_SHIFT) & (1<<15))
						SendMessage(hwnd,WM_COMMAND,40147,0);
					else
						SendMessage(hwnd,WM_COMMAND,40047,0);
					return 0;
				
				// //////////////	
				// Next track
				case 4: 
					SendMessage(hwnd,WM_COMMAND,40048,0);
					return 0;
				
				// //////////////	
				// Open File
				case 5: 
					SetForegroundWindow(hwnd);
					if (GetKeyState(VK_CONTROL) & (1<<15))
						SendMessage(hwnd,WM_COMMAND,40185,0);
					else if (GetKeyState(VK_SHIFT) & (1<<15))
						SendMessage(hwnd,WM_COMMAND,40187,0);
					else
						SendMessage(hwnd,WM_COMMAND,40029,0);
					return 0;
				
				// //////////////	
				// Volume UP
				case 6:
					{
						int k, nMax;
						if (GetKeyState(VK_CONTROL) & (1<<15))
							nMax = 10;
						else
							nMax = 5;

						for (k=0; k<nMax; k++)
							SendMessage(hwnd,WM_COMMAND,40058,0);
					}
					return 0;
				
						
			
				}
			return 0;
		
		case WM_RBUTTONDOWN:
				switch (which)
				{
					// Volume DOWN
					case 6:
						{	int k, nMax;
							if (GetKeyState(VK_CONTROL) & (1<<15))
								nMax = 10;
							else
								nMax = 5;

							for (k=0; k<nMax; k++)
								SendMessage(hwnd,WM_COMMAND,40059,0);
						}
						return 0;
			
				
				}
				return 0;
		

		}
	}
	return CallWindowProc(lpWndProcOld,hwnd,message,wParam,lParam);
}

/* ************************************************************************ */
int init()
{
	{
		static char c[512];
		char filename[512],*p;
		GetModuleFileName(plugin.hDllInstance,filename,sizeof(filename));
		p = filename+lstrlen(filename);
		while (p >= filename && *p != '\\') p--;
		wsprintf((plugin.description=c),"%s Plug-In v1.0 (%s)",szAppName,p+1);
	}
	config_read();
	{
		int i;
		for (i = 0; i < 7; i ++)
			Icons[i] = LoadIcon(plugin.hDllInstance,MAKEINTRESOURCE(IDI_ICON1+i));
	}


	lpWndProcOld = (void *) GetWindowLong(plugin.hwndParent,GWL_WNDPROC);
	SetWindowLong(plugin.hwndParent, GWL_WNDPROC, (LONG)WndProc);

	do_icons();

	return 0;
}


/* ************************************************************************ */
BOOL CALLBACK ConfigProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_INITDIALOG:
			{
				int i;
				for (i = 0; i < 7; i++)
					CheckDlgButton(hwndDlg,IDC_PREV1+i,(config_enabled & (1<<i))?BST_CHECKED:BST_UNCHECKED);
			}
			return FALSE;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_APPLY:
				case IDOK:

					config_enabled=0;
					{
						int i;
						for (i = 0; i < 7; i++)
							if (IsDlgButtonChecked(hwndDlg,IDC_PREV1+i))
								config_enabled |= 1<<i;
					}
					do_icons();
				case IDCANCEL:
					if (LOWORD(wParam) != IDC_APPLY) 
						EndDialog(hwndDlg,0);
				return FALSE;
			}
	}
	return FALSE;
}

/* ************************************************************************ */
void config_read()
{
	char ini_file[MAX_PATH], *p;
	GetModuleFileName(plugin.hDllInstance,ini_file,sizeof(ini_file));
	p=ini_file+lstrlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	lstrcat(ini_file,"plugin.ini");

	config_enabled = GetPrivateProfileInt(szAppName,"ButtonsEnabled",config_enabled,ini_file);
}

/* ************************************************************************ */
void config_write()
{
	char ini_file[MAX_PATH], *p;
	char string[32];
	GetModuleFileName(plugin.hDllInstance,ini_file,sizeof(ini_file));
	p=ini_file+lstrlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	lstrcat(ini_file,"plugin.ini");

	wsprintf(string,"%d",config_enabled);
	WritePrivateProfileString(szAppName,"ButtonsEnabled",string,ini_file);
}

/* ************************************************************************ */
__declspec( dllexport ) winampGeneralPurposePlugin * winampGetGeneralPurposePlugin()
{
	return &plugin;
}


BOOL StartEZPlaylist(HANDLE hInstance)
{
	HACCEL hAccel;
	MSG msg;
	static bInit = TRUE;

	if (bInit == TRUE)
	{
		if (!InitApplication(hInstance))
				return (FALSE); 
		
		bInit= FALSE;
	}


	if (ghWndMain != NULL)
	{
	    ShowWindow (ghWndMain, SW_SHOW);
		UpdateWindow (ghWndMain);
		return (TRUE);
	}

	// Perform initializations that apply to a specific instance 
	// Make the window visible; update its client area; and return "success" 
	ghWndMain = CreateDialogParam (hInstance, "EZPLAYLIST", NULL, (DLGPROC)PlaylistDlg_Proc, SW_SHOW);
                           
	// If window could not be created, return "failure"
	if (!ghWndMain)
		return (FALSE);

	
    ShowWindow (ghWndMain, SW_SHOW);
    UpdateWindow (ghWndMain);
	
	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));
	
	while (GetMessage (&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(ghWndMain, hAccel, &msg))
		{
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}

	ghWndMain = NULL;
	return TRUE;

}
//
//
//   FUNCTION: InitApplication(HANDLE) 
//   PURPOSE: Initializes window data and registers window class 
//   COMMENTS:
//		This function registers the window class for the main window.	
// 
BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wc;

// Fill in window class structure with parameters that describe the       
// main window.                                                           

	wc.style = 0;
	wc.lpfnWndProc = DefDlgProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)); 
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENUBAR);
	wc.lpszClassName = "EZPLAYLIST";
    return (RegisterClass(&wc));
}

//
//
//   FUNCTION: InitWindows(HANDLE, int)
//   PURPOSE: Creates the main window.
//   COMMENTS: N/A
//	
// 

BOOL InitWindows(HANDLE hInstance, int nCmdShow) 
{


	return (TRUE);      
}	


